/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports,require("@tensorflow/tfjs-core"),require("path"),require("fs"),require("worker_threads"),require("perf_hooks")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","path","fs","worker_threads","perf_hooks"],n):n(((e=e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.path,e.fs,e.worker_threads,e.perf_hooks)}(this,(function(e,n,t,a,r,u){"use strict";var s,i;let o;t=t&&t.hasOwnProperty("default")?t.default:t,a=a&&a.hasOwnProperty("default")?a.default:a,r=r&&r.hasOwnProperty("default")?r.default:r,u=u&&u.hasOwnProperty("default")?u.default:u,function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(s||(s={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu"}(i||(i={}));const l={kernelName:n._FusedMatMul,backendName:"wasm",setupFunc:function(e){o=e.wasm.cwrap(n._FusedMatMul,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{a:r,b:u,bias:s,preluActivationWeights:l}=n;if("float32"!==r.dtype||"float32"!==u.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:d,transposeB:c,activation:p,leakyreluAlpha:m}=a,f=t.dataIdMap.get(r.dataId).id,h=t.dataIdMap.get(u.dataId).id;let b=0;if(null!=s){const e=t.dataIdMap.get(s.dataId);if(1!==e.shape.length)throw new Error(`_FusedMatMul only supports rank-1 bias but got rank ${e.shape.length}.`);b=e.id}const _=null==l?0:t.dataIdMap.get(l.dataId).id,y=i[p];if(null==y)throw new Error(p+" activation not yet supported for FusedConv2D in the wasm backend.");const g=d?r.shape[2]:r.shape[1],w=c?u.shape[1]:u.shape[2],k=r.shape[0],I=t.makeOutput([k,g,w],r.dtype),v=t.dataIdMap.get(I.dataId).id,S=new Uint8Array(new Int32Array(r.shape).buffer),E=new Uint8Array(new Int32Array(u.shape).buffer);return o(f,S,r.shape.length,h,E,u.shape.length,d,c,y,b,_,m||0,v),I}};function d(e){let t;return{kernelName:e,backendName:"wasm",setupFunc:function(n){t=n.wasm.cwrap(e,null,["number","number"])},kernelFunc:function(e){const{backend:a,inputs:{x:r}}=e,u=a.dataIdMap.get(r.dataId).id,s=a.makeOutput(r.shape,r.dtype),i=a.dataIdMap.get(s.dataId).id;return 0===n.util.sizeFromShape(s.shape)||t(u,i),s}}}const c=d(n.Abs);function p(e,t,a){let r;return{kernelName:e,backendName:"wasm",setupFunc:function(n){r=n.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(u){const{backend:i,inputs:o}=u,{a:l,b:d}=o,c=i.dataIdMap.get(l.dataId).id,p=i.dataIdMap.get(d.dataId).id,m=null!=a?a:l.dtype,f=n.backend_util.assertAndGetBroadcastShape(l.shape,d.shape),h=i.makeOutput(f,m);if(0===n.util.sizeFromShape(f))return h;const b=new Uint8Array(new Int32Array(l.shape).buffer),_=new Uint8Array(new Int32Array(d.shape).buffer),y=i.dataIdMap.get(h.dataId).id,g=()=>r(c,b,l.shape.length,p,_,d.shape.length,s[l.dtype],y);if(t&&"float32"===l.dtype)return g(),h;const w=n.backend_util.getBroadcastDims(l.shape,f),k=n.backend_util.getBroadcastDims(d.shape,f),I=w.every((e,n)=>e===n),v=k.every((e,n)=>e===n);if(I&&v)return g(),h;throw new Error(`Broadcasting along outer dims is not yet supported for ${l.dtype} ${e}.`)}}}const m=p(n.Add,!0);let f;const h={kernelName:n.AddN,backendName:"wasm",setupFunc:function(e){f=e.wasm.cwrap(n.AddN,null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a}=e,r=a.makeOutput(t[0].shape,t[0].dtype);if(0===n.util.sizeFromShape(r.shape))return r;const u=t.map(e=>a.dataIdMap.get(e.dataId).id),i=new Uint8Array(new Int32Array(u).buffer),o=a.dataIdMap.get(r.dataId).id;return f(i,u.length,s[r.dtype],o),r}};function b(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype),r=t.typedArrayFromHeap(n);return t.typedArrayFromHeap(a).set(r),a}const _={kernelName:n.Identity,backendName:"wasm",kernelFunc:b};let y;function g(e){const{inputs:n,backend:t,attrs:a}=e,[r,u]=function(e,n){const t=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&t.push(e[r]),1!==e[n[r]]&&a.push(n[r]);for(let e=0;e<a.length;++e){let n=-1;for(let t=0;t<a.length;++t)a[t]>=e&&(-1===n||a[n]>a[t])&&(n=t);a[n]=e}return[t,a]}(n.x.shape,a.perm);let i=!0;for(let e=0;e<u.length;e++)u[e]!==e&&(i=!1);const o=function(e,n){const t=new Array(e.length);for(let a=0;a<t.length;a++)t[a]=e[n[a]];return t}(n.x.shape,a.perm),l={dataId:n.x.dataId,shape:r,dtype:n.x.dtype};if(i){const e=b({inputs:n,backend:t});return e.shape=o,e}const d=t.makeOutput(o,l.dtype),c=t.dataIdMap.get(l.dataId).id,p=t.dataIdMap.get(d.dataId).id,m=new Uint8Array(new Int32Array(u).buffer),f=new Uint8Array(new Int32Array(l.shape).buffer);return y(c,f,l.shape.length,s[l.dtype],p,m,u.length),d}const w={kernelName:n.Transpose,backendName:"wasm",kernelFunc:g,setupFunc:function(e){y=e.wasm.cwrap(n.Transpose,null,["number","array","number","number","number","array","number"])}};function k(e,t,a){const r=e.shape,u=e.shape.length,s=n.util.parseAxisParam(t,r);let i=s;const o=n.backend_util.getAxesPermutation(i,u);let l=null,d=!1;if(null!=o){const t=new Array(u);for(let e=0;e<t.length;e++)t[e]=r[o[e]];i=n.backend_util.getInnerMostAxes(i.length,u),l=g({inputs:{x:e},attrs:{perm:o},backend:a});const s=a.dataIdMap.get(e.dataId).id;a.dataIdMap.get(l.dataId).id!==s&&(d=!0)}return{transposed:l,originalAxes:s,axes:i,inputWasTransposed:d}}let I;const v={kernelName:n.ArgMax,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:u}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,inputWasTransposed:m}=k(i,u,t);if(m){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e)}const f=d.shape.slice(0,-1),h=t.makeOutput(f,"int32"),b=t.dataIdMap.get(h.dataId).id,_=n.util.sizeFromShape(h.shape),y=d.shape[p[0]];return I(l,s[d.dtype],_,y,b),m&&t.disposeData(c.dataId),h},setupFunc:function(e){I=e.wasm.cwrap(n.ArgMax,null,["number","number","number","number","number"])}};let S;const E={kernelName:n.AvgPool,backendName:"wasm",setupFunc:function(e){S=e.wasm.cwrap(n.AvgPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,u=t.x,s=r.dataIdMap.get(u.dataId).id,{filterSize:i,strides:o,pad:l,dimRoundingMode:d}=a,c=n.backend_util.computePool2DInfo(u.shape,i,o,1,l,d),p=c.filterHeight,m=c.filterWidth,f=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,_=c.padInfo.left,y=c.strideHeight,g=c.strideWidth,w=c.inChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");if(1!==c.dilationWidth||1!==c.dilationHeight)throw new Error(`was backend only supports average pooling with dilation = [1, 1], got [${c.dilationHeight}, ${c.dilationWidth}].`);const k=r.makeOutput(c.outShape,"float32"),I=r.dataIdMap.get(k.dataId).id;return S(s,u.shape[0],u.shape[1],u.shape[2],p,m,f,h,b,_,y,g,w,I),k}};function A(e){const{inputs:t,attrs:a}=e,{x:r}=t,{shape:u}=a,s=n.util.sizeFromShape(r.shape),i=n.util.inferFromImplicitShape(u,s);return n.util.assert(s===n.util.sizeFromShape(i),()=>`new shape: ${i}, old shape: ${r.shape}. New shape and old shape must have the same number of elements.`),{dataId:r.dataId,shape:i,dtype:r.dtype}}const M={kernelName:n.Reshape,backendName:"wasm",kernelFunc:A};let x;const N={kernelName:n.BatchMatMul,backendName:"wasm",setupFunc:function(e){x=e.wasm.cwrap(n.BatchMatMul,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{a:u,b:s}=t,{transposeA:i,transposeB:o}=r;if("float32"!==u.dtype||"float32"!==s.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const l=u.shape.length,d=s.shape.length,c=i?u.shape[l-2]:u.shape[l-1],p=o?s.shape[d-1]:s.shape[d-2],m=i?u.shape[l-1]:u.shape[l-2],f=o?s.shape[d-2]:s.shape[d-1],h=u.shape.slice(0,-2),b=s.shape.slice(0,-2),_=n.util.sizeFromShape(h),y=n.util.sizeFromShape(b),g=_===y||1===_||1===y;n.util.assert(l>=2&&d>=2&&g,()=>`Error in matMul: the input batch dimensions must either be the same or at least one input batch dimension must be 1. Got input batch dimensions of (${h}) and (${b}).`);const w=(_>y?u.shape.slice(0,-2):s.shape.slice(0,-2)).concat([m,f]);n.util.assert(c===p,()=>`Error in matMul: inner shapes (${c}) and (${p}) of Tensors with shapes ${u.shape} and ${s.shape} and transposeA=${i} and transposeB=${o} must match.`);const k=o?[y,f,p]:[y,p,f],I=A({inputs:{x:u},backend:a,attrs:{shape:i?[_,c,m]:[_,m,c]}}),v=A({inputs:{x:s},backend:a,attrs:{shape:k}}),S=a.dataIdMap.get(I.dataId).id,E=a.dataIdMap.get(v.dataId).id,M=i?I.shape[2]:I.shape[1],N=o?v.shape[1]:v.shape[2],F=Math.max(_,y),T=a.makeOutput([F,M,N],I.dtype),O=a.dataIdMap.get(T.dataId).id,C=new Uint8Array(new Int32Array(I.shape).buffer),R=new Uint8Array(new Int32Array(v.shape).buffer);return x(S,C,I.shape.length,E,R,v.shape.length,i,o,O),T.shape=w,T}};function F(e){const{inputs:{x:n},attrs:{dtype:t},backend:a}=e,r=a.makeOutput(n.shape,t),u=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(r).set(u),r}const T={kernelName:n.Cast,backendName:"wasm",kernelFunc:F};let O;const C={kernelName:n.ClipByValue,backendName:"wasm",setupFunc:function(e){O=e.wasm.cwrap(n.ClipByValue,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,{clipValueMin:u,clipValueMax:s}=a,i=t.dataIdMap.get(r.dataId).id,o=t.makeOutput(r.shape,r.dtype),l=t.dataIdMap.get(o.dataId).id;return O(i,u,s,l),o}};function R(e){const{inputs:t,backend:a}=e,r=n.util.parseAxisParam(e.attrs.axis,t[0].shape)[0],u=n.backend_util.computeOutShape(t.map(e=>e.shape),r),s=t.filter(e=>n.util.sizeFromShape(e.shape)>0);if(1===s.length)return b({inputs:{x:s[0]},backend:a});const i=a.makeOutput(u,t[0].dtype);if(0===n.util.sizeFromShape(u))return i;const o=s.map(e=>e.shape);n.backend_util.assertParamsConsistent(o,r);const l=n.util.sizeFromShape(s[0].shape.slice(0,r));let d=0;const c=s.map(e=>{const t=n.util.sizeFromShape(e.shape.slice(r));return d+=t,t}),p=s.map(e=>a.typedArrayFromHeap(e)),m=a.typedArrayFromHeap(i);for(let e=0;e<l;e++){let n=e*d;for(let t=0;t<p.length;t++){const a=c[t],r=e*a,u=p[t].subarray(r,r+a);m.set(u,n),n+=a}}return i}const D={kernelName:n.Concat,backendName:"wasm",kernelFunc:R};let P;const W={kernelName:n.Conv2D,backendName:"wasm",setupFunc:function(e){P=e.wasm.cwrap(n.Conv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:u,filter:s}=t,i=r.dataIdMap.get(u.dataId).id,o=r.dataIdMap.get(s.dataId).id,{strides:l,dilations:d,pad:c,dimRoundingMode:p,dataFormat:m}=a,f=n.backend_util.convertConv2DDataFormat(m),h=n.backend_util.computeConv2DInfo(u.shape,s.shape,l,d,c,p,!1,f),b=h.filterHeight,_=h.filterWidth,y=h.padInfo.top,g=h.padInfo.right,w=h.padInfo.bottom,k=h.padInfo.left,I=h.dilationHeight,v=h.dilationWidth,S=h.strideHeight,E=h.strideWidth,A=h.inChannels,M=h.outChannels,x="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error("wasm backend Conv2D does not support dataFormat:'"+h.dataFormat+"'. Please use 'channelsLast'.");const N=r.makeOutput(h.outShape,"float32"),F=r.dataIdMap.get(N.dataId).id;return P(i,u.shape[0],u.shape[1],u.shape[2],o,b,_,y,g,w,k,x,I,v,S,E,A,M,F),N}};let B;const L={kernelName:n.Conv2DBackpropInput,backendName:"wasm",setupFunc:function(e){B=e.wasm.cwrap(n.Conv2DBackpropInput,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{dy:u,filter:s}=a,{strides:i,pad:o,dataFormat:l,dimRoundingMode:d,inputShape:c}=r,p=n.backend_util.convertConv2DDataFormat(l),m=n.backend_util.computeConv2DInfo(c,s.shape,i,1,o,d,!1,p),{batchSize:f,filterHeight:h,filterWidth:b,inChannels:_,inHeight:y,inWidth:g,outChannels:w,outHeight:k,outWidth:I,strideHeight:v,strideWidth:S}=m,E=h-1-m.padInfo.top,A=b-1-m.padInfo.left,M="channelsLast"===m.dataFormat,x=n.util.computeStrides(m.inShape),N=n.util.computeStrides(u.shape),[F,T,O]=n.util.computeStrides(s.shape),C=x[0],R=M?x[1]:x[2],D=M?x[2]:1,P=M?1:x[1],W=N[0],L=M?N[1]:N[2],H=M?N[2]:1,U=M?1:N[1],z=t.makeOutput(m.inShape,"float32"),q=t.dataIdMap.get(z.dataId).id,j=t.dataIdMap.get(u.dataId).id,V=t.dataIdMap.get(s.dataId).id;return B(j,V,f,h,b,y,g,_,k,I,w,v,S,E,A,F,T,O,C,R,D,P,W,L,H,U,q),z}},H=d(n.Cos);var U;let z;!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(U||(U={}));let q;let j;let V;function G(e){const{inputs:t,attrs:a,backend:r}=e,{input:u}=t,{dim:s}=a,i=u.shape.length,o=u.shape.slice();let l=s;return s<0&&(n.util.assert(-(i+1)<=s,()=>`Axis must be in the interval [${-(i+1)}, ${i}]`),l=i+s+1),o.splice(l,0,1),A({inputs:{x:u},backend:r,attrs:{shape:o}})}let K;let X;let $;let Y;let Q;let Z;let J;let ee;let ne;let te;let ae;function re(e,n){const t=new Int32Array(e.wasm.HEAPU8.buffer,n,4),a=t[0],r=t[1],u=t[2],s=t[3];return e.wasm._free(n),{pSelectedIndices:a,selectedSize:r,pSelectedScores:u,pValidOutputs:s}}let ue;let se;let ie;let oe;let le;let de;let ce;function pe(e,t,a,r,u){const s=n.slice_util.isSliceContinous(r,t,a),i=n.util.sizeFromShape(a),o=n.util.computeStrides(r);if(s){const a=n.slice_util.computeFlatOffset(t,o);return"string"===u?e.slice(a,a+i):e.subarray(a,a+i)}const l="string"===u?n.backend_util.fromUint8ToStringArray(e):e,d=n.buffer(r,u,l),c=n.buffer(a,u);for(let e=0;e<c.size;++e){const n=c.indexToLoc(e),a=n.map((e,n)=>e+t[n]);c.set(d.get(...a),...n)}return"string"===u?n.backend_util.fromStringArrayToUint8(c.values):c.values}let me;let fe;let he;let be;let _e;let ye;function ge(e){const{inputs:{x:t},attrs:{begin:a,size:r},backend:u}=e,[s,i]=n.slice_util.parseSliceParams(t,a,r),o=n.slice_util.isSliceContinous(t.shape,s,i),l=u.readSync(t.dataId),d=u.makeOutput(i,t.dtype),c=n.util.computeStrides(t.shape),p=u.dataIdMap.get(d.dataId);if(o){const e=n.slice_util.computeFlatOffset(s,c);if("string"===t.dtype)p.stringBytes=l.slice(e,e+n.util.sizeFromShape(i));else{u.typedArrayFromHeap(d).set(l.subarray(e,e+n.util.sizeFromShape(i)))}return d}if("string"===t.dtype){const e=pe(l,s,i,t.shape,t.dtype);return p.stringBytes=e,d}const m=u.typedArrayFromHeap(d),f=t.shape.length;if(2===f)!function(e,n,t,a,r){let u=0;const s=a[0],i=a[1],o=s+r[0];for(let a=s;a<o;a++){const s=a*n+i;t.set(e.subarray(s,s+r[1]),u),u+=r[1]}}(l,c[0],m,s,i);else if(3===f)!function(e,n,t,a,r,u){let s=0;const i=r[0],o=r[1],l=r[2],d=i+u[0],c=o+u[1];for(let r=i;r<d;r++)for(let i=o;i<c;i++){const o=r*n+i*t+l;a.set(e.subarray(o,o+u[2]),s),s+=u[2]}}(l,c[0],c[1],m,s,i);else if(4===f)!function(e,n,t,a,r,u,s){let i=0;const o=u[0],l=u[1],d=u[2],c=o+s[0],p=l+s[1],m=d+s[2],f=u[3];for(let u=o;u<c;u++)for(let o=l;o<p;o++)for(let l=d;l<m;l++){const d=u*n+o*t+l*a+f;r.set(e.subarray(d,d+s[3]),i),i+=s[3]}}(l,c[0],c[1],c[2],m,s,i);else{const e=pe(l,s,i,t.shape,t.dtype);m.set(e)}return d}let we;let ke;let Ie;let ve;let Se;const Ee=[c,m,h,v,E,N,T,C,D,W,L,H,{kernelName:n.CropAndResize,backendName:"wasm",setupFunc:function(e){z=e.wasm.cwrap(n.CropAndResize,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{method:r,extrapolationValue:u,cropSize:s}=a,{image:i,boxes:o,boxInd:l}=t,d=o.shape[0],[c,p]=s,m=[d,c,p,i.shape[3]];let f,h=n.dataIdMap.get(i.dataId);"float32"!==i.dtype&&(f=F({backend:n,inputs:{x:i},attrs:{dtype:"float32"}}),h=n.dataIdMap.get(f.dataId));const b=h.id,_=n.dataIdMap.get(o.dataId).id,y=n.dataIdMap.get(l.dataId).id,g=n.makeOutput(m,"float32"),w=n.dataIdMap.get(g.dataId).id,k=new Uint8Array(new Int32Array(i.shape).buffer);return z(b,_,y,d,k,c,p,U[r],u,w),null!=f&&n.disposeData(f.dataId),g}},{kernelName:n.Cumsum,backendName:"wasm",setupFunc:function(e){q=e.wasm.cwrap(n.Cumsum,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{x:u}=t,{axis:i,exclusive:o,reverse:l}=r,d=u.shape.length;n.util.assert("float32"===u.dtype||"int32"===u.dtype,()=>`cumsum does not support ${u.dtype} tensors in the WASM backend`);const c=n.backend_util.getAxesPermutation([i],d);let p=u;null!==c&&(p=g({inputs:{x:u},attrs:{perm:c},backend:a}));const m=n.backend_util.getInnerMostAxes(1,d)[0];n.backend_util.assertAxesAreInnerMostDims("cumsum",[m],d);const f=a.makeOutput(p.shape,p.dtype),h=p.shape[m],b=a.dataIdMap.get(p.dataId).id,_=a.dataIdMap.get(f.dataId).id;q(b,o?1:0,l?1:0,h,_,s[u.dtype]);let y=f;if(null!==c){y=g({inputs:{x:f},attrs:{perm:n.backend_util.getUndoAxesPermutation(c)},backend:a}),a.disposeData(p.dataId),a.disposeData(f.dataId)}return y}},{kernelName:n.DepthToSpace,backendName:"wasm",setupFunc:function(e){j=e.wasm.cwrap(n.DepthToSpace,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:u}=a,{blockSize:s,dataFormat:i}=r;n.util.assert(s>1,()=>"blockSize should be > 1 for depthToSpace, but was: "+s);const o=u.shape[0],l="NHWC"===i?u.shape[1]:u.shape[2],d="NHWC"===i?u.shape[2]:u.shape[3],c="NHWC"===i?u.shape[3]:u.shape[1],p=l*s,m=d*s,f=c/(s*s),h="NHWC"===i?[o,p,m,f]:[o,f,p,m],b=t.makeOutput(h,"float32"),_=t.dataIdMap.get(u.dataId).id,y=new Uint8Array(new Int32Array(n.util.computeStrides(u.shape)).buffer),g=new Uint8Array(new Int32Array(h).buffer),w=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer),k=t.dataIdMap.get(b.dataId).id;return j(_,s,"NHWC"===i?1:0,y,u.shape.length-1,g,w,h.length,k),b}},{kernelName:n.DepthwiseConv2dNative,backendName:"wasm",setupFunc:function(e){V=e.wasm.cwrap(n.DepthwiseConv2dNative,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:u,filter:s}=t,i=r.dataIdMap.get(u.dataId).id,o=r.dataIdMap.get(s.dataId).id,{strides:l,dilations:d,pad:c,dimRoundingMode:p}=a,m=null==d?[1,1]:d,f=n.backend_util.computeConv2DInfo(u.shape,s.shape,l,m,c,p,!0),h=f.filterHeight,b=f.filterWidth,_=f.padInfo.top,y=f.padInfo.right,g=f.padInfo.bottom,w=f.padInfo.left,k=f.dilationHeight,I=f.dilationWidth,v=f.strideHeight,S=f.strideWidth,E=f.inChannels,A=f.outChannels,M="SAME"===f.padInfo.type?1:0;if("channelsLast"!==f.dataFormat)throw new Error("wasm backend DepthwiseConv2dNative does not support dataFormat:'"+f.dataFormat+"'. Please use 'channelsLast'.");const x=r.makeOutput(f.outShape,"float32"),N=r.dataIdMap.get(x.dataId).id;return V(i,u.shape[0],u.shape[1],u.shape[2],o,h,b,_,y,g,w,M,k,I,v,S,E,A,N),x}},p(n.Equal,!1,"bool"),d(n.Exp),{kernelName:n.ExpandDims,backendName:"wasm",kernelFunc:G},{kernelName:n.Fill,backendName:"wasm",kernelFunc:function(e){const{attrs:{shape:n,value:t,dtype:a},backend:r}=e,u=r.makeOutput(n,a);return r.typedArrayFromHeap(u).fill(t),u}},{kernelName:n.FlipLeftRight,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t}=e,{image:a}=n,r=t.makeOutput(a.shape,a.dtype),u=t.dataIdMap.get(a.dataId).id,s=t.dataIdMap.get(r.dataId).id,[i,o,l,d]=a.shape;return K(u,i,o,l,d,s),r},setupFunc:function(e){K=e.wasm.cwrap(n.FlipLeftRight,null,["number","number","number","number","number","number"])}},d(n.Floor),p(n.FloorDiv,!1),l,{kernelName:n.FusedBatchNorm,backendName:"wasm",setupFunc:function(e){X=e.wasm.cwrap(n.FusedBatchNorm,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{varianceEpsilon:u}=r,{x:s,mean:i,variance:o,offset:l,scale:d}=a,c=t.dataIdMap.get(s.dataId).id,p=t.dataIdMap.get(i.dataId).id,m=t.dataIdMap.get(o.dataId).id,f=null!=l?t.dataIdMap.get(l.dataId).id:0,h=null!=d?t.dataIdMap.get(d.dataId).id:0,b=t.makeOutput(s.shape,s.dtype);if(0===n.util.sizeFromShape(s.shape))return b;const _=t.dataIdMap.get(b.dataId).id;return X(c,p,m,f,h,u,_),b}},{kernelName:n.FusedConv2D,backendName:"wasm",setupFunc:function(e){$=e.wasm.cwrap(n.FusedConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:u,filter:s,bias:o,preluActivationWeights:l}=t,{strides:d,pad:c,dilations:p,dataFormat:m,dimRoundingMode:f,activation:h,leakyreluAlpha:b}=a,_=n.backend_util.computeConv2DInfo(u.shape,s.shape,d,p,c,f),y=i[h];if(null==y)throw new Error(h+" activation not yet supported for FusedConv2D in the wasm backend.");const g=r.dataIdMap.get(u.dataId).id,w=r.dataIdMap.get(s.dataId).id,k=_.outChannels;let I=0;if(null!=o){const e=r.dataIdMap.get(o.dataId);if(1!==e.shape.length)throw new Error(`FusedConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==k)throw new Error(`FusedConv2D bias shape (${e.shape}) does not match the number of output channels (${k})`);I=e.id}const v=_.filterHeight,S=_.filterWidth,E=_.padInfo.top,A=_.padInfo.right,M=_.padInfo.bottom,x=_.padInfo.left,N=_.dilationHeight,F=_.dilationWidth,T=_.strideHeight,O=_.strideWidth,C=_.inChannels,R="SAME"===_.padInfo.type?1:0,D=_.batchSize,P=_.inHeight,W=_.inWidth;if("NHWC"!==m)throw new Error("wasm backend FusedConv2D does not support dataFormat:'"+m+"'. Please use 'NHWC'.");const B=r.makeOutput(_.outShape,"float32"),L=r.dataIdMap.get(B.dataId).id,H=null==l?0:r.dataIdMap.get(l.dataId).id;return $(g,D,P,W,w,v,S,I,E,A,M,x,R,N,F,T,O,C,k,y,H,b||0,L),B}},{kernelName:n.FusedDepthwiseConv2D,backendName:"wasm",setupFunc:function(e){Y=e.wasm.cwrap(n.FusedDepthwiseConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:u,filter:s,bias:o,preluActivationWeights:l}=t,{strides:d,pad:c,dilations:p,dataFormat:m,dimRoundingMode:f,activation:h,leakyreluAlpha:b}=a,_=n.backend_util.computeConv2DInfo(u.shape,s.shape,d,p,c,f,!0),y=i[h];if(null==y)throw new Error(h+" activation not yet supported for FusedDepthwiseConv2D in the wasm backend.");const g=r.dataIdMap.get(u.dataId).id,w=r.dataIdMap.get(s.dataId).id,k=_.outChannels;let I=0;if(null!=o){const e=r.dataIdMap.get(o.dataId);if(1!==e.shape.length)throw new Error(`FusedDepthwiseConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==k)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not match the number of output channels (${k})`);I=e.id}const v=_.filterHeight,S=_.filterWidth,E=_.padInfo.top,A=_.padInfo.right,M=_.padInfo.bottom,x=_.padInfo.left,N=_.dilationHeight,F=_.dilationWidth,T=_.strideHeight,O=_.strideWidth,C=_.inChannels,R="SAME"===_.padInfo.type?1:0,D=_.batchSize,P=_.inHeight,W=_.inWidth;if("NHWC"!==m)throw new Error("wasm backend FusedDepthwiseConv2D does not support dataFormat:'"+m+"'. Please use 'NHWC'.");const B=r.makeOutput(_.outShape,"float32"),L=r.dataIdMap.get(B.dataId).id,H=null==l?0:r.dataIdMap.get(l.dataId).id;return Y(g,D,P,W,w,v,S,I,E,A,M,x,R,N,F,T,O,C,k,y,H,b||0,L),B}},{kernelName:n.GatherNd,backendName:"wasm",setupFunc:function(e){Q=e.wasm.cwrap(n.GatherNd,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a}=e,{params:r,indices:u}=a,[i,o,l,d]=n.gather_util.prepareAndValidate(r,u),c=t.makeOutput(i,r.dtype);if(0===o)return c;const p=u.shape,m=p[p.length-1],f=t.dataIdMap.get(r.dataId).id,h=t.dataIdMap.get(u.dataId).id,b=new Uint8Array(new Int32Array(d).buffer),_=t.dataIdMap.get(c.dataId).id;return Q(f,s[r.dtype],h,o,m,l,b,_),c}},{kernelName:n.GatherV2,backendName:"wasm",setupFunc:function(e){Z=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:u,indices:i}=a,{axis:o,batchDims:l}=r,d=n.util.parseAxisParam(o,u.shape)[0],c=n.backend_util.segment_util.collectGatherOpShapeInfo(u,i,d,l),p=A({inputs:{x:u},attrs:{shape:[c.batchSize,c.outerSize,c.dimSize,c.sliceSize]},backend:t}),m=n.util.sizeFromShape(i.shape),f=A({inputs:{x:i},attrs:{shape:[c.batchSize,m/c.batchSize]},backend:t}),h=[c.batchSize,c.outerSize,m/c.batchSize,c.sliceSize],b=t.makeOutput(h,u.dtype);if(0===n.util.sizeFromShape(u.shape))return b;const _=p.shape.length-1,y=t.dataIdMap.get(p.dataId).id,g=t.dataIdMap.get(f.dataId).id,w=t.dataIdMap.get(b.dataId).id,k=new Uint8Array(new Int32Array(n.util.computeStrides(p.shape)).buffer),I=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer);return Z(y,s[u.dtype],k,_,g,c.batchSize,I,w),b.shape=c.outputShape,b}},p(n.Greater,!1,"bool"),p(n.GreaterEqual,!1,"bool"),_,{kernelName:n.LeakyRelu,backendName:"wasm",setupFunc:function(e){J=e.wasm.cwrap(n.LeakyRelu,null,["number","number","number"])},kernelFunc:function(e){const{inputs:{x:t},attrs:{alpha:a},backend:r}=e,u=r.dataIdMap.get(t.dataId).id,s=r.makeOutput(t.shape,t.dtype);if(0!==n.util.sizeFromShape(t.shape)){const e=r.dataIdMap.get(s.dataId).id;J(u,a,e)}return s}},p(n.Less,!1,"bool"),p(n.LessEqual,!1,"bool"),d(n.Log),p(n.LogicalAnd,!1,"bool"),{kernelName:n.Max,backendName:"wasm",setupFunc:function(e){ee=e.wasm.cwrap(n.Max,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{reductionIndices:u,keepDims:s}=r,{x:i}=a;let o=t.dataIdMap.get(i.dataId).id,l=i;const{transposed:d,axes:c,originalAxes:p,inputWasTransposed:m}=k(i,u,t);if(m){l=d,o=t.dataIdMap.get(d.dataId).id}const f=l.shape.length;n.backend_util.assertAxesAreInnerMostDims("max",c,f);const[h,b]=n.backend_util.computeOutAndReduceShapes(l.shape,c),_=n.util.sizeFromShape(b),y=t.makeOutput(h,i.dtype);if(0!==n.util.sizeFromShape(l.shape)){const e=t.dataIdMap.get(y.dataId).id;ee(o,_,e)}if(m&&t.disposeData(d.dataId),s){const e=n.backend_util.expandShapeToKeepDim(y.shape,p);y.shape=e}return y}},p(n.Maximum,!1),{kernelName:n.MaxPool,backendName:"wasm",setupFunc:function(e){ne=e.wasm.cwrap(n.MaxPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,u=t.x,s=r.dataIdMap.get(u.dataId).id,{filterSize:i,strides:o,pad:l,dimRoundingMode:d}=a,c=n.backend_util.computePool2DInfo(u.shape,i,o,1,l,d),p=c.filterHeight,m=c.filterWidth,f=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,_=c.padInfo.left,y=c.dilationHeight,g=c.dilationWidth,w=c.strideHeight,k=c.strideWidth,I=c.inChannels,v=c.outChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");const S=r.makeOutput(c.outShape,"float32"),E=r.dataIdMap.get(S.dataId).id;return ne(s,u.shape[0],u.shape[1],u.shape[2],p,m,f,h,b,_,y,g,w,k,I,v,E),S}},{kernelName:n.Mean,backendName:"wasm",setupFunc:function(e){te=e.wasm.cwrap(n.Mean,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:u,keepDims:s}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,originalAxes:m,inputWasTransposed:f}=k(i,u,t);let h=p;if(f){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e,h=n.backend_util.getInnerMostAxes(h.length,d.shape.length))}n.backend_util.assertAxesAreInnerMostDims("mean",h,d.shape.length);const[b,_]=n.backend_util.computeOutAndReduceShapes(d.shape,h),y=n.util.sizeFromShape(_);let g=d;"float32"!==d.dtype&&(g=F({backend:t,inputs:{x:d},attrs:{dtype:"float32"}}),l=t.dataIdMap.get(g.dataId).id);const w=t.makeOutput(b,"float32");if(0!==n.util.sizeFromShape(d.shape)){const e=t.dataIdMap.get(w.dataId).id;te(l,y,e)}if(f&&t.disposeData(c.dataId),s){const e=n.backend_util.expandShapeToKeepDim(w.shape,m);w.shape=e}return"float32"!==d.dtype&&t.disposeData(g.dataId),w}},{kernelName:n.Min,backendName:"wasm",setupFunc:function(e){ae=e.wasm.cwrap(n.Min,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:u,keepDims:s}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,originalAxes:m,inputWasTransposed:f}=k(i,u,t);if(f){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e)}const h=d.shape.length;n.backend_util.assertAxesAreInnerMostDims("min",p,h);const[b,_]=n.backend_util.computeOutAndReduceShapes(d.shape,p),y=n.util.sizeFromShape(_),g=t.makeOutput(b,d.dtype);if(0!==n.util.sizeFromShape(d.shape)){const e=t.dataIdMap.get(g.dataId).id;ae(l,y,e)}if(f&&t.disposeData(c.dataId),s){const e=n.backend_util.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}},p(n.Minimum,!1),p(n.Multiply,!0),d(n.Neg),{kernelName:n.NonMaxSuppressionV3,backendName:"wasm",setupFunc:function(e){ue=e.wasm.cwrap(n.NonMaxSuppressionV3,"number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:u,scoreThreshold:s}=a,{boxes:i,scores:o}=t,l=n.dataIdMap.get(i.dataId).id,d=n.dataIdMap.get(o.dataId).id,c=ue(l,d,u,r,s),{pSelectedIndices:p,selectedSize:m,pSelectedScores:f,pValidOutputs:h}=re(n,c);return n.wasm._free(f),n.wasm._free(h),n.makeOutput([m],"int32",p)}},{kernelName:n.NonMaxSuppressionV4,backendName:"wasm",setupFunc:function(e){se=e.wasm.cwrap(n.NonMaxSuppressionV4,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:u,scoreThreshold:s,padToMaxOutputSize:i}=a,{boxes:o,scores:l}=t,d=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(l.dataId).id,p=se(d,c,u,r,s,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=re(n,p);return n.wasm._free(h),[n.makeOutput([f],"int32",m),n.makeOutput([],"int32",b)]}},{kernelName:n.NonMaxSuppressionV5,backendName:"wasm",setupFunc:function(e){ie=e.wasm.cwrap(n.NonMaxSuppressionV5,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:u,scoreThreshold:s,softNmsSigma:i}=a,{boxes:o,scores:l}=t,d=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(l.dataId).id,p=ie(d,c,u,r,s,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=re(n,p);return n.wasm._free(b),[n.makeOutput([f],"int32",m),n.makeOutput([f],"float32",h)]}},p(n.NotEqual,!1,"bool"),{kernelName:n.OneHot,backendName:"wasm",setupFunc:function(e){oe=e.wasm.cwrap(n.OneHot,null,["number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{indices:r}=n,{depth:u,onValue:s,offValue:i}=a,o=t.makeOutput([...r.shape,u],"int32"),l=t.dataIdMap.get(o.dataId).id,d=t.dataIdMap.get(r.dataId).id;return oe(d,u,s,i,l),o}},{kernelName:n.OnesLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(1),a}},{kernelName:n.Pack,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{axis:u}=r;if(1===t.length)return G({inputs:{input:t[0]},backend:a,attrs:{dim:u}});const s=t[0].shape,i=t[0].dtype;return t.forEach(e=>{n.util.assertShapesMatch(s,e.shape,"All tensors passed to stack must have matching shapes"),n.util.assert(i===e.dtype,()=>"All tensors passed to stack must have matching dtypes")}),R({inputs:t.map(e=>G({inputs:{input:e},backend:a,attrs:{dim:u}})),backend:a,attrs:{axis:u}})}},{kernelName:n.PadV2,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{paddings:a,constantValue:r}}=e,u=a.map((e,t)=>e[0]+n.shape[t]+e[1]),i=t.dataIdMap.get(n.dataId).id,o=t.makeOutput(u,n.dtype),l=t.dataIdMap.get(o.dataId).id,d=new Uint8Array(new Int32Array(n.shape).buffer),c=a.map(e=>e[0]),p=a.map(e=>e[1]),m=new Uint8Array(new Int32Array(c).buffer),f=new Uint8Array(new Int32Array(p).buffer);return le(i,d,n.shape.length,s[n.dtype],m,f,r,l),o},setupFunc:function(e){le=e.wasm.cwrap(n.PadV2,null,["number","array","number","number","array","array","number","number"])}},p(n.Pow,!1),{kernelName:n.Prelu,backendName:"wasm",setupFunc:function(e){de=e.wasm.cwrap(n.Prelu,null,["number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t}=e,{x:a,alpha:r}=n,u=t.dataIdMap.get(a.dataId).id,s=t.dataIdMap.get(r.dataId).id,i=t.makeOutput(a.shape,"float32"),o=t.dataIdMap.get(i.dataId).id;return de(u,s,o),i}},{kernelName:n.Prod,backendName:"wasm",setupFunc:function(e){ce=e.wasm.cwrap(n.Prod,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:u,keepDims:i}=r,{x:o}=a,l=t.dataIdMap.get(o.dataId).id;let d=l,c=o;const{transposed:p,axes:m,originalAxes:f,inputWasTransposed:h}=k(o,u,t);let b=m;if(h){const e=t.dataIdMap.get(p.dataId).id;e!==l&&(c=p,d=e,b=n.backend_util.getInnerMostAxes(b.length,c.shape.length))}n.backend_util.assertAxesAreInnerMostDims("prod",b,c.shape.length);const[_,y]=n.backend_util.computeOutAndReduceShapes(c.shape,b),g=n.util.sizeFromShape(y),w=t.makeOutput(_,c.dtype);if(0!==n.util.sizeFromShape(c.shape)){const e=t.dataIdMap.get(w.dataId).id;ce(d,g,s[w.dtype],e)}if(h&&t.disposeData(p.dataId),i){const e=n.backend_util.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},{kernelName:n.Range,backendName:"wasm",kernelFunc:e=>{const{backend:t,attrs:a}=e,{start:r,stop:u,step:s,dtype:i}=a,o=function(e,t,a,r){if(e===t||e<t&&a<0||t<e&&a>1)return n.util.makeZerosTypedArray(0,r);const u=Math.abs(Math.ceil((t-e)/a)),s=n.util.makeZerosTypedArray(u,r);t<e&&1===a&&(a=-1),s[0]=e;for(let e=1;e<s.length;e++)s[e]=s[e-1]+a;return s}(r,u,s,i),l=t.makeOutput([o.length],i);return t.typedArrayFromHeap(l).set(o),l}},p(n.RealDiv,!0),d(n.Relu),d(n.Relu6),M,{kernelName:n.ResizeBilinear,backendName:"wasm",setupFunc:function(e){me=e.wasm.cwrap(n.ResizeBilinear,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{images:u}=a,{alignCorners:s,halfPixelCenters:i,size:o}=r,[l,d]=o,[c,p,m,f]=u.shape,h=[c,l,d,f];let b,_=t.dataIdMap.get(u.dataId);"float32"!==_.dtype&&(b=F({backend:t,inputs:{x:u},attrs:{dtype:"float32"}}),_=t.dataIdMap.get(b.dataId));const y=_.id,g=t.makeOutput(h,"float32");if(0===n.util.sizeFromShape(u.shape))return g;const w=t.dataIdMap.get(g.dataId).id;return me(y,c,p,m,f,l,d,s?1:0,i?1:0,w),null!=b&&t.disposeData(b.dataId),g}},{kernelName:n.Reverse,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{x:u}=t,{dims:s}=r,i=n.util.parseAxisParam(s,u.shape);if(0===u.shape.length)return b({inputs:{x:u},backend:a});const o=a.makeOutput(u.shape,u.dtype),l=a.dataIdMap.get(u.dataId).id,d=a.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(i).buffer),p=new Uint8Array(new Int32Array(u.shape).buffer);return fe(l,c,i.length,p,u.shape.length,d),A({inputs:{x:o},attrs:{shape:u.shape},backend:a})},setupFunc:function(e){fe=e.wasm.cwrap(n.Reverse,null,["number","array","number","array","number","number"])}},{kernelName:n.RotateWithOffset,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{image:u}=t,{radians:s,fillValue:i,center:o}=r,l=a.makeOutput(u.shape,u.dtype),d=a.dataIdMap.get(u.dataId).id,c=a.dataIdMap.get(l.dataId).id,[p,m,f,h]=u.shape,[b,_]=n.backend_util.getImageCenter(o,m,f),y="number"==typeof i?[i,i,i,0===i?0:255]:[...i,255],g=new Uint8Array(new Int32Array(y).buffer);return he(d,p,m,f,h,s,b,_,g,y.length,c),l},setupFunc:function(e){he=e.wasm.cwrap(n.RotateWithOffset,null,["number","number","number","number","number","number","number","number","array","number","number"])}},d(n.Rsqrt),{kernelName:n.ScatterNd,backendName:"wasm",setupFunc:function(e){be=e.wasm.cwrap(n.ScatterNd,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{indices:u,updates:i}=a,{shape:o}=r,l=t.makeOutput(o,i.dtype);if(0===n.util.sizeFromShape(o))return l;const{sliceRank:d,numUpdates:c,sliceSize:p,strides:m,outputSize:f}=n.scatter_util.calculateShapes(i,u,o),h=t.dataIdMap.get(u.dataId).id,b=t.dataIdMap.get(i.dataId).id,_=new Uint8Array(new Int32Array(m).buffer),y=t.dataIdMap.get(l.dataId).id;return be(h,b,s[i.dtype],d,c,p,_,f,y),l}},{kernelName:n.Select,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a}=e,{condition:r,t:u,e:s}=t,i=a.dataIdMap.get(r.dataId).id,o=a.dataIdMap.get(u.dataId).id,l=a.dataIdMap.get(s.dataId).id,d=a.makeOutput(u.shape,u.dtype),c=a.dataIdMap.get(d.dataId).id,p=r.shape.length,m=u.shape.length,f=0===p||p>1||1===m?1:n.util.sizeFromShape(u.shape.slice(1));return _e(i,o,l,f,c),d},setupFunc:function(e){_e=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}},{kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){ye=e.wasm.cwrap(n.Sigmoid,null,["number","number"])},kernelFunc:function(e){const{backend:t,inputs:{x:a}}=e,r=t.dataIdMap.get(a.dataId).id,u=t.makeOutput(a.shape,a.dtype),s=t.dataIdMap.get(u.dataId).id;return 0===n.util.sizeFromShape(u.shape)||ye(r,s),u}},d(n.Sin),{kernelName:n.Slice,backendName:"wasm",kernelFunc:ge},{kernelName:n.Softmax,backendName:"wasm",setupFunc:function(e){we=e.wasm.cwrap(n.Softmax,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:{logits:a},attrs:{dim:r}}=e,u=t.dataIdMap.get(a.dataId).id,s=t.makeOutput(a.shape,a.dtype),i=t.dataIdMap.get(s.dataId).id,o=a.shape[r],l=n.util.sizeFromShape(a.shape)/o;return 0===n.util.sizeFromShape(s.shape)||we(u,i,o,l),s}},{kernelName:n.SplitV,backendName:"wasm",kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:u}=t,{numOrSizeSplits:s,axis:i}=a,o=n.util.parseAxisParam(i,u.shape)[0],l=n.backend_util.prepareSplitSize(u,s,i),d=new Array(u.shape.length).fill(0),c=u.shape.slice();return l.map(e=>{const n=[...c];n[o]=e;const t=ge({inputs:{x:u},attrs:{begin:d,size:n},backend:r});return d[o]+=e,t})}},d(n.Sqrt),d(n.Square),p(n.SquaredDifference,!0),{kernelName:n.StridedSlice,backendName:"wasm",setupFunc:function(e){ke=e.wasm.cwrap(n.StridedSlice,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:u}=a;let{begin:s,end:i,strides:o}=r;null==o&&(o=new Array(s.length));const{beginMask:l,endMask:d,ellipsisMask:c,newAxisMask:p,shrinkAxisMask:m}=r,f=n.backend_util.slice_util.maskToAxes(c);if(f.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==c&&0!==p)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==c&&0!==m)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");const h=u.shape.length-s.length,b=n.backend_util.slice_util.maskToAxes(p),_=u.shape.slice();b.forEach(e=>{s[e]=0,i[e]=1,_.splice(e,0,1)});const y=A({inputs:{x:u},attrs:{shape:_},backend:t}),{begin:g,end:w,strides:k}=n.backend_util.slice_util.getNormalizedAxes(y.shape,f,h,s,i,o,l,d,c);s=g,i=w,o=k;const I=n.backend_util.slice_util.maskToAxes(m);I.forEach(e=>{i[e]=s[e]+1,o[e]=1});const v=n.backend_util.slice_util.computeOutShape(s,i,o),S=v.filter((e,n)=>-1===I.indexOf(n));if(o.every(e=>1===e)){return A({inputs:{x:ge({inputs:{x:u},attrs:{begin:s,size:v},backend:t})},attrs:{shape:S},backend:t})}const E=t.makeOutput(S,"float32");if(!S.some(e=>0===e)){const e=t.dataIdMap.get(y.dataId).id,a=new Uint8Array(new Int32Array(n.util.computeStrides(y.shape)).buffer),r=new Uint8Array(new Int32Array(s).buffer),u=new Uint8Array(new Int32Array(i).buffer),l=new Uint8Array(new Int32Array(o).buffer),d=new Uint8Array(new Int32Array(S).buffer),c=new Uint8Array(new Int32Array(n.util.computeStrides(S)).buffer),p=t.dataIdMap.get(E.dataId).id;ke(e,a,y.shape.length,r,u,l,d,c,S.length,p)}return A({inputs:{x:E},attrs:{shape:S},backend:t})}},p(n.Sub,!0),{kernelName:n.Sum,backendName:"wasm",setupFunc:function(e){Ie=e.wasm.cwrap(n.Sum,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:u,keepDims:s}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,originalAxes:m,inputWasTransposed:f}=k(i,u,t);let h=p;if(f){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e,h=n.backend_util.getInnerMostAxes(h.length,d.shape.length))}n.backend_util.assertAxesAreInnerMostDims("sum",h,d.shape.length);const[b,_]=n.backend_util.computeOutAndReduceShapes(d.shape,h),y=n.util.sizeFromShape(_),g=t.makeOutput(b,d.dtype);if(0!==n.util.sizeFromShape(d.shape)){const e=t.dataIdMap.get(g.dataId).id;Ie(l,y,e)}if(f&&t.disposeData(c.dataId),s){const e=n.backend_util.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}},d(n.Tanh),{kernelName:n.Tile,backendName:"wasm",setupFunc:function(e){ve=e.wasm.cwrap(n.Tile,null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,u=t.dataIdMap.get(r.dataId).id,{reps:i}=a,o=new Array(r.shape.length);for(let e=0;e<o.length;e++)o[e]=r.shape[e]*i[e];const l=new Uint8Array(new Int32Array(r.shape).buffer),d=new Uint8Array(new Int32Array(o).buffer),c=t.makeOutput(o,r.dtype),p=t.dataIdMap.get(c.dataId).id;return ve(u,l,r.shape.length,d,o.length,s[c.dtype],p),c}},{kernelName:n.TopK,backendName:"wasm",setupFunc:function(e){Se=e.wasm.cwrap(n.TopK,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:({inputs:e,backend:n,attrs:t})=>{const{x:a}=e,{k:r,sorted:u}=t,i=n.dataIdMap.get(a.dataId).id,o=new Uint8Array(new Int32Array(a.shape).buffer),l=a.shape.slice();l[l.length-1]=r;const d=n.makeOutput(l,a.dtype),c=n.dataIdMap.get(d.dataId).id,p=n.makeOutput(l,"int32"),m=n.dataIdMap.get(p.dataId).id;return Se(i,o,a.shape.length,s[a.dtype],r,u,c,m),[d,p]}},w,{kernelName:n.Unpack,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{value:r}=n;let{axis:u}=a;u<0&&(u+=r.shape.length);const s=r.shape[u],i=r.shape.length,o=new Array(i-1);let l=0;for(let e=0;e<i;e++)e!==u&&(o[l++]=r.shape[e]);const d=new Array(s),c=new Array(i).fill(0),p=r.shape.slice();p[u]=1;for(let e=0;e<d.length;e++)c[u]=e,d[e]=ge({inputs:{x:r},attrs:{begin:c,size:p},backend:t});return d.map(({dataId:e,dtype:n})=>({dataId:e,dtype:n,shape:o}))}},{kernelName:n.ZerosLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(0),a}}];for(const e of Ee)n.registerKernel(e);const Ae=n.env();function Me(e,n){return e(n={exports:{}},n.exports),n.exports}Ae.registerFlag("WASM_HAS_SIMD_SUPPORT",async()=>WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]))),Ae.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",async()=>{if(Ae.get("IS_NODE"))return!1;try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))}catch(e){return!1}});var xe=Me((function(e,n){var s,i=(s="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(s=s||__filename),function(e){function n(){return x.buffer!=V&&J(x.buffer),G}function s(){return x.buffer!=V&&J(x.buffer),K}function i(){return x.buffer!=V&&J(x.buffer),X}function o(){return x.buffer!=V&&J(x.buffer),$}function l(){return x.buffer!=V&&J(x.buffer),Y}var d,c=void 0!==(e=e||{})?e:{},p=void 0,m={};for(d in c)c.hasOwnProperty(d)&&(m[d]=c[d]);var f=!1,h=!1,b=!1,_=!1;f="object"==typeof window,h="function"==typeof importScripts,b="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,_=!f&&!b&&!h;var y=c.ENVIRONMENT_IS_PTHREAD||!1;y&&(V=c.buffer,ee=c.DYNAMIC_BASE,ne=c.DYNAMICTOP_PTR);var g,w,k,I,v="";function S(e){return c.locateFile?c.locateFile(e,v):v+e}if(b){var E;v=h?t.dirname(v)+"/":__dirname+"/",g=function(e,n){return k||(k=a),I||(I=t),e=I.normalize(e),k.readFileSync(e,n?null:"utf8")},w=function(e){var n=g(e,!0);return n.buffer||(n=new Uint8Array(n)),D(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof pt))throw e})),process.on("unhandledRejection",ke),c.inspect=function(){return"[Emscripten Module object]"};try{E=r}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Worker=E.Worker}else _?("undefined"!=typeof read&&(g=function(e){return read(e)}),w=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(D("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(f||h)&&(h?v=self.location.href:document.currentScript&&(v=document.currentScript.src),v=0!==v.indexOf("blob:")?v.substr(0,v.lastIndexOf("/")+1):"",b?(g=function(e,n){return k||(k=a),I||(I=t),e=I.normalize(e),k.readFileSync(e,n?null:"utf8")},w=function(e){var n=g(e,!0);return n.buffer||(n=new Uint8Array(n)),D(n.buffer),n}):(g=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},h&&(w=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)})));b&&"undefined"==typeof performance&&(performance=u.performance);var A,M,x,N=c.print||console.log.bind(console),F=c.printErr||console.warn.bind(console);for(d in m)m.hasOwnProperty(d)&&(c[d]=m[d]);m=null,c.arguments&&c.arguments,c.thisProgram&&c.thisProgram,c.quit&&c.quit,c.wasmBinary&&(A=c.wasmBinary),c.noExitRuntime&&(M=c.noExitRuntime),"object"!=typeof WebAssembly&&F("no native wasm support detected");var T,O=new WebAssembly.Table({initial:167,maximum:167,element:"anyfunc"}),C=0,R=!1;function D(e,n){e||ke("Assertion failed: "+n)}function P(e){var n=c["_"+e];return D(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function W(e,n,t,a,r){var u={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);z(e,n=lt(t),t)}return n},array:function(e){var n=lt(e.length);return j(e,n),n}},s=P(e),i=[],o=0;if(a)for(var l=0;l<a.length;l++){var d=u[t[l]];d?(0===o&&(o=ot()),i[l]=d(a[l])):i[l]=a[l]}var c=s.apply(null,i);return c=function(e){return"string"===n?H(e):"boolean"===n?Boolean(e):e}(c),0!==o&&dt(o),c}function B(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?P(e):function(){return W(e,n,t,arguments)}}function L(e,n,t){for(var a=n+t,r="";!(n>=a);){var u=e[n++];if(!u)return r;if(128&u){var s=63&e[n++];if(192!=(224&u)){var i=63&e[n++];if((u=224==(240&u)?(15&u)<<12|s<<6|i:(7&u)<<18|s<<12|i<<6|63&e[n++])<65536)r+=String.fromCharCode(u);else{var o=u-65536;r+=String.fromCharCode(55296|o>>10,56320|1023&o)}}else r+=String.fromCharCode((31&u)<<6|s)}else r+=String.fromCharCode(u)}return r}function H(e,n){return e?L(s(),e,n):""}function U(e,n,t,a){if(!(a>0))return 0;for(var r=t,u=t+a-1,s=0;s<e.length;++s){var i=e.charCodeAt(s);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++s)),i<=127){if(t>=u)break;n[t++]=i}else if(i<=2047){if(t+1>=u)break;n[t++]=192|i>>6,n[t++]=128|63&i}else if(i<=65535){if(t+2>=u)break;n[t++]=224|i>>12,n[t++]=128|i>>6&63,n[t++]=128|63&i}else{if(t+3>=u)break;n[t++]=240|i>>18,n[t++]=128|i>>12&63,n[t++]=128|i>>6&63,n[t++]=128|63&i}}return n[t]=0,t-r}function z(e,n,t){return U(e,s(),n,t)}function q(e){for(var n=0,t=0;t<e.length;++t){var a=e.charCodeAt(t);a>=55296&&a<=57343&&(a=65536+((1023&a)<<10)|1023&e.charCodeAt(++t)),a<=127?++n:n+=a<=2047?2:a<=65535?3:4}return n}function j(e,t){n().set(e,t)}var V,G,K,X,$,Y,Q=65536;function Z(e,n){return e%n>0&&(e+=n-e%n),e}function J(e){V=e,c.HEAP8=G=new Int8Array(e),c.HEAP16=new Int16Array(e),c.HEAP32=X=new Int32Array(e),c.HEAPU8=K=new Uint8Array(e),c.HEAPU16=new Uint16Array(e),c.HEAPU32=$=new Uint32Array(e),c.HEAPF32=new Float32Array(e),c.HEAPF64=Y=new Float64Array(e)}var ee=5256464,ne=12656,te=c.INITIAL_MEMORY||16777216;if(y)x=c.wasmMemory,V=c.buffer;else if(c.wasmMemory)x=c.wasmMemory;else if(!((x=new WebAssembly.Memory({initial:te/Q,maximum:2147483648/Q,shared:!0})).buffer instanceof SharedArrayBuffer))throw F("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),b&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");function ae(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?c.dynCall_v(t):c.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n(c)}}x&&(V=x.buffer),te=V.byteLength,J(V),y||(i()[ne>>2]=ee);var re=[],ue=[],se=[],ie=[];function oe(){if(!y){if(c.preRun)for("function"==typeof c.preRun&&(c.preRun=[c.preRun]);c.preRun.length;)pe(c.preRun.shift());ae(re)}}function le(){ae(ue)}function de(){y||ae(se)}function ce(){if(!y){if(c.postRun)for("function"==typeof c.postRun&&(c.postRun=[c.postRun]);c.postRun.length;)me(c.postRun.shift());ae(ie)}}function pe(e){re.unshift(e)}function me(e){ie.unshift(e)}var fe=Math.ceil,he=Math.floor,be=0,_e=null,ye=null;function ge(e){D(!y,"addRunDependency cannot be used in a pthread worker"),be++,c.monitorRunDependencies&&c.monitorRunDependencies(be)}function we(e){if(be--,c.monitorRunDependencies&&c.monitorRunDependencies(be),0==be&&(null!==_e&&(clearInterval(_e),_e=null),ye)){var n=ye;ye=null,n()}}function ke(e){throw c.onAbort&&c.onAbort(e),y&&console.error("Pthread aborting at "+(new Error).stack),N(e+=""),F(e),R=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}function Ie(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}c.preloadedImages={},c.preloadedAudios={};var ve="data:application/octet-stream;base64,";function Se(e){return Ie(e,ve)}var Ee="file://";function Ae(e){return Ie(e,Ee)}var Me="tfjs-backend-wasm-threaded-simd.wasm";function xe(){try{if(A)return new Uint8Array(A);if(w)return w(Me);throw"both async and sync fetching of the wasm failed"}catch(e){ke(e)}}function Ne(){return A||!f&&!h||"function"!=typeof fetch||Ae(Me)?new Promise((function(e,n){e(xe())})):fetch(Me,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+Me+"'";return e.arrayBuffer()})).catch((function(){return xe()}))}function Fe(){var e={a:Kn};function n(e,n){var t=e.exports;if(c.asm=t,T=n,!y){var a=je.unusedWorkers.length;je.unusedWorkers.forEach((function(e){je.loadWasmModuleToWorker(e,(function(){--a||we()}))}))}}function t(e){n(e.instance,e.module)}function a(n){return Ne().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){F("failed to asynchronously prepare wasm: "+e),ke(e)}))}if(y||ge(),c.instantiateWasm)try{return c.instantiateWasm(e,n)}catch(e){return F("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(A||"function"!=typeof WebAssembly.instantiateStreaming||Se(Me)||Ae(Me)||"function"!=typeof fetch)return a(t);fetch(Me,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){F("wasm streaming compile failed: "+e),F("falling back to ArrayBuffer instantiation"),a(t)}))}))}(),{}}Se(Me)||(Me=S(Me));var Te={};function Oe(){je.initRuntime()}y||ue.push({func:function(){Yn()}});var Ce=0,Re=0,De=0;function Pe(e,n,t){Ce=e|=0,De=n|=0,Re=t|=0}c.__register_pthread_ptr=Pe;var We={EPERM:63,ENOENT:44,ESRCH:71,EINTR:27,EIO:29,ENXIO:60,E2BIG:1,ENOEXEC:45,EBADF:8,ECHILD:12,EAGAIN:6,EWOULDBLOCK:6,ENOMEM:48,EACCES:2,EFAULT:21,ENOTBLK:105,EBUSY:10,EEXIST:20,EXDEV:75,ENODEV:43,ENOTDIR:54,EISDIR:31,EINVAL:28,ENFILE:41,EMFILE:33,ENOTTY:59,ETXTBSY:74,EFBIG:22,ENOSPC:51,ESPIPE:70,EROFS:69,EMLINK:34,EPIPE:64,EDOM:18,ERANGE:68,ENOMSG:49,EIDRM:24,ECHRNG:106,EL2NSYNC:156,EL3HLT:107,EL3RST:108,ELNRNG:109,EUNATCH:110,ENOCSI:111,EL2HLT:112,EDEADLK:16,ENOLCK:46,EBADE:113,EBADR:114,EXFULL:115,ENOANO:104,EBADRQC:103,EBADSLT:102,EDEADLOCK:16,EBFONT:101,ENOSTR:100,ENODATA:116,ETIME:117,ENOSR:118,ENONET:119,ENOPKG:120,EREMOTE:121,ENOLINK:47,EADV:122,ESRMNT:123,ECOMM:124,EPROTO:65,EMULTIHOP:36,EDOTDOT:125,EBADMSG:9,ENOTUNIQ:126,EBADFD:127,EREMCHG:128,ELIBACC:129,ELIBBAD:130,ELIBSCN:131,ELIBMAX:132,ELIBEXEC:133,ENOSYS:52,ENOTEMPTY:55,ENAMETOOLONG:37,ELOOP:32,EOPNOTSUPP:138,EPFNOSUPPORT:139,ECONNRESET:15,ENOBUFS:42,EAFNOSUPPORT:5,EPROTOTYPE:67,ENOTSOCK:57,ENOPROTOOPT:50,ESHUTDOWN:140,ECONNREFUSED:14,EADDRINUSE:3,ECONNABORTED:13,ENETUNREACH:40,ENETDOWN:38,ETIMEDOUT:73,EHOSTDOWN:142,EHOSTUNREACH:23,EINPROGRESS:26,EALREADY:7,EDESTADDRREQ:17,EMSGSIZE:35,EPROTONOSUPPORT:66,ESOCKTNOSUPPORT:137,EADDRNOTAVAIL:4,ENETRESET:39,EISCONN:30,ENOTCONN:53,ETOOMANYREFS:141,EUSERS:136,EDQUOT:19,ESTALE:72,ENOTSUP:138,ENOMEDIUM:148,EILSEQ:25,EOVERFLOW:61,ECANCELED:11,ENOTRECOVERABLE:56,EOWNERDEAD:62,ESTRPIPE:135},Be=13568;function Le(e,t){if(e<=0||e>n().length||!0&e||t<0)return-28;if(0==t)return 0;t>=2147483647&&(t=1/0);var a=Atomics.load(i(),Be>>2),r=0;if(a==e&&Atomics.compareExchange(i(),Be>>2,a,0)==a&&(r=1,--t<=0))return 1;var u=Atomics.notify(i(),e>>2,t);if(u>=0)return u+r;throw"Atomics.notify returned an unexpected value "+u}function He(e){if(y)throw"Internal Error! _kill_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _kill_thread!";i()[e+12>>2]=0;var n=je.pthreads[e];n.worker.terminate(),je.freeThreadData(n),je.runningWorkers.splice(je.runningWorkers.indexOf(n.worker),1),n.worker.pthread=void 0}function Ue(e){if(y)throw"Internal Error! _cancel_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _cancel_thread!";je.pthreads[e].worker.postMessage({cmd:"cancel"})}function ze(e){if(y)throw"Internal Error! _cleanup_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _cleanup_thread!";i()[e+12>>2]=0;var n=je.pthreads[e];if(n){var t=n.worker;je.returnWorkerToPool(t)}}c._emscripten_futex_wake=Le;var qe,je={MAIN_THREAD_ID:1,mainThreadInfo:{schedPolicy:0,schedPrio:0},unusedWorkers:[],runningWorkers:[],initRuntime:function(){Pe(je.mainThreadBlock,!h,1),rt(je.mainThreadBlock)},initMainThreadBlock:function(){for(var e=0;e<8;++e)je.allocateUnusedWorker();for(je.mainThreadBlock=12816,e=0;e<58;++e)o()[je.mainThreadBlock/4+e]=0;i()[je.mainThreadBlock+12>>2]=je.mainThreadBlock;var n=je.mainThreadBlock+156;for(i()[n>>2]=n,e=0;e<128;++e)o()[3264+e]=0;Atomics.store(o(),je.mainThreadBlock+104>>2,13056),Atomics.store(o(),je.mainThreadBlock+40>>2,je.mainThreadBlock),Atomics.store(o(),je.mainThreadBlock+44>>2,42)},initWorker:function(){},pthreads:{},exitHandlers:null,setThreadStatus:function(){},runExitHandlers:function(){if(null!==je.exitHandlers){for(;je.exitHandlers.length>0;)je.exitHandlers.pop()();je.exitHandlers=null}y&&C&&tt()},threadExit:function(e){var n=zn();n&&(Atomics.store(o(),n+4>>2,e),Atomics.store(o(),n+0>>2,1),Atomics.store(o(),n+60>>2,1),Atomics.store(o(),n+64>>2,0),je.runExitHandlers(),Le(n+0,2147483647),Pe(0,0,0),C=0,y&&postMessage({cmd:"exit"}))},threadCancel:function(){je.runExitHandlers(),Atomics.store(o(),C+4>>2,-1),Atomics.store(o(),C+0>>2,1),Le(C+0,2147483647),C=0,Pe(0,0,0),postMessage({cmd:"cancelDone"})},terminateAllThreads:function(){for(var e in je.pthreads)(a=je.pthreads[e])&&a.worker&&je.returnWorkerToPool(a.worker);je.pthreads={};for(var n=0;n<je.unusedWorkers.length;++n)(t=je.unusedWorkers[n]).terminate();for(je.unusedWorkers=[],n=0;n<je.runningWorkers.length;++n){var t,a=(t=je.runningWorkers[n]).pthread;je.freeThreadData(a),t.terminate()}je.runningWorkers=[]},freeThreadData:function(e){if(e){if(e.threadInfoStruct){var n=i()[e.threadInfoStruct+104>>2];i()[e.threadInfoStruct+104>>2]=0,Zn(n),Zn(e.threadInfoStruct)}e.threadInfoStruct=0,e.allocatedOwnStack&&e.stackBase&&Zn(e.stackBase),e.stackBase=0,e.worker&&(e.worker.pthread=null)}},returnWorkerToPool:function(e){delete je.pthreads[e.pthread.thread],je.unusedWorkers.push(e),je.runningWorkers.splice(je.runningWorkers.indexOf(e),1),je.freeThreadData(e.pthread),e.pthread=void 0},receiveObjectTransfer:function(e){},loadWasmModuleToWorker:function(e,n){e.onmessage=function(t){var a=t.data,r=a.cmd;if(e.pthread&&(je.currentProxiedOperationCallerThread=e.pthread.threadInfoStruct),a.targetThread&&a.targetThread!=zn()){var u=je.pthreads[a.targetThread];return u?u.worker.postMessage(t.data,a.transferList):console.error('Internal error! Worker sent a message "'+r+'" to target pthread '+a.targetThread+", but that thread no longer exists!"),void(je.currentProxiedOperationCallerThread=void 0)}"processQueuedMainThreadWork"===r?at():"spawnThread"===r?Hn(t.data):"cleanupThread"===r?ze(a.thread):"killThread"===r?He(a.thread):"cancelThread"===r?Ue(a.thread):"loaded"===r?(e.loaded=!0,n&&n(e),e.runPthread&&(e.runPthread(),delete e.runPthread)):"print"===r?N("Thread "+a.threadId+": "+a.text):"printErr"===r?F("Thread "+a.threadId+": "+a.text):"alert"===r?alert("Thread "+a.threadId+": "+a.text):"exit"===r?e.pthread&&Atomics.load(o(),e.pthread.thread+68>>2)&&je.returnWorkerToPool(e):"cancelDone"===r?je.returnWorkerToPool(e):"objectTransfer"===r?je.receiveObjectTransfer(t.data):"setimmediate"===t.data.target?e.postMessage(t.data):F("worker sent an unknown command "+r),je.currentProxiedOperationCallerThread=void 0},e.onerror=function(e){F("pthread sent an error! "+e.filename+":"+e.lineno+": "+e.message)},b&&(e.on("message",(function(n){e.onmessage({data:n})})),e.on("error",(function(n){e.onerror(n)})),e.on("exit",(function(e){console.log("worker exited - TODO: update the worker queue?")}))),e.postMessage({cmd:"load",urlOrBlob:c.mainScriptUrlOrBlob||p,wasmMemory:x,wasmModule:T,DYNAMIC_BASE:ee,DYNAMICTOP_PTR:ne})},allocateUnusedWorker:function(){var e=S("tfjs-backend-wasm-threaded-simd.worker.js");je.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==je.unusedWorkers.length&&(je.allocateUnusedWorker(),je.loadWasmModuleToWorker(je.unusedWorkers[0])),je.unusedWorkers.length>0?je.unusedWorkers.pop():null},busySpinWait:function(e){for(var n=performance.now()+e;performance.now()<n;);}};function Ve(e,n){dt(e)}function Ge(){return M}function Ke(e,n,t,a){ke("Assertion failed: "+H(e)+", at: "+[n?H(n):"unknown filename",t,a?H(a):"unknown function"])}function Xe(e,n){_main(e,n)}function $e(e){return i()[Jn()>>2]=e,e}function Ye(e,n){if(y)return un(1,1,e,n)}function Qe(e,n){if(e==n)postMessage({cmd:"processQueuedMainThreadWork"});else if(y)postMessage({targetThread:e,cmd:"processThreadQueue"});else{var t=je.pthreads[e],a=t&&t.worker;if(!a)return;a.postMessage({cmd:"processThreadQueue"})}return 1}function Ze(){ke()}function Je(e,n){}function en(e,t,a){if(e<=0||e>n().length||!0&e)return-28;if(h){var r=Atomics.wait(i(),e>>2,t,a);if("timed-out"===r)return-73;if("not-equal"===r)return-6;if("ok"===r)return 0;throw"Atomics.wait returned an unexpected value "+r}if(t!=Atomics.load(i(),e>>2))return-6;var u=performance.now(),s=u+a;Atomics.store(i(),Be>>2,e);for(var o=e;e==o;){if((u=performance.now())>s)return-73;at(),e=Atomics.load(i(),Be>>2)}return 0}function nn(){return 0|De}function tn(){return 0|Re}function an(e,n,t){s().copyWithin(e,n,n+t)}function rn(){return navigator.hardwareConcurrency}function un(e,n){for(var t=arguments.length-2,a=ot(),r=lt(8*t),u=r>>3,s=0;s<t;s++)l()[u+s]=arguments[2+s];var i=st(e,t,r,n);return dt(a),i}c.establishStackSpace=Ve,c.getNoExitRuntime=Ge,qe=b?function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:y?function(){return performance.now()-c.__performance_now_clock_drift}:"undefined"!=typeof dateNow?dateNow:function(){return performance.now()};var sn=[];function on(e,n){on.array||(on.array=[]);var t,a=on.array;for(a.length=0;t=s()[e++];)100===t||102===t?(n=n+7&-8,a.push(l()[n>>3]),n+=8):(n=n+3&-4,a.push(i()[n>>2]),n+=4);return a}function ln(e,n,t){sn.length=n;for(var a=t>>3,r=0;r<n;r++)sn[r]=l()[a+r];var u=e<0,s=u?Te[-e-1]:Gn[e];if(u){var i=on(sn[1],sn[2]);return s.apply(null,i)}return s.apply(null,sn)}function dn(){return s().length}function cn(e){try{return x.grow(e-V.byteLength+65535>>>16),J(x.buffer),1}catch(e){}}function pn(e){e>>>=0;var n=dn();if(e<=n)return!1;if(e>2147483648)return!1;for(var t=1;t<=4;t*=2){var a=n*(1+.2/t);if(a=Math.min(a,e+100663296),cn(Math.min(2147483648,Z(Math.max(16777216,e,a),65536))))return!0}return!1}var mn={keyEvent:0,mouseEvent:0,wheelEvent:0,uiEvent:0,focusEvent:0,deviceOrientationEvent:0,deviceMotionEvent:0,fullscreenChangeEvent:0,pointerlockChangeEvent:0,visibilityChangeEvent:0,touchEvent:0,previousFullscreenElement:null,previousScreenX:null,previousScreenY:null,removeEventListenersRegistered:!1,removeAllEventListeners:function(){for(var e=mn.eventHandlers.length-1;e>=0;--e)mn._removeHandler(e);mn.eventHandlers=[],mn.deferredCalls=[]},registerRemoveEventListeners:function(){mn.removeEventListenersRegistered||(mn.removeEventListenersRegistered=!0)},deferredCalls:[],deferCall:function(e,n,t){function a(e,n){if(e.length!=n.length)return!1;for(var t in e)if(e[t]!=n[t])return!1;return!0}for(var r in mn.deferredCalls){var u=mn.deferredCalls[r];if(u.targetFunction==e&&a(u.argsList,t))return}mn.deferredCalls.push({targetFunction:e,precedence:n,argsList:t}),mn.deferredCalls.sort((function(e,n){return e.precedence<n.precedence}))},removeDeferredCalls:function(e){for(var n=0;n<mn.deferredCalls.length;++n)mn.deferredCalls[n].targetFunction==e&&(mn.deferredCalls.splice(n,1),--n)},canPerformEventHandlerRequests:function(){return mn.inEventHandler&&mn.currentEventHandler.allowsDeferredCalls},runDeferredCalls:function(){if(mn.canPerformEventHandlerRequests())for(var e=0;e<mn.deferredCalls.length;++e){var n=mn.deferredCalls[e];mn.deferredCalls.splice(e,1),--e,n.targetFunction.apply(null,n.argsList)}},inEventHandler:0,currentEventHandler:null,eventHandlers:[],removeAllHandlersOnTarget:function(e,n){for(var t=0;t<mn.eventHandlers.length;++t)mn.eventHandlers[t].target!=e||n&&n!=mn.eventHandlers[t].eventTypeString||mn._removeHandler(t--)},_removeHandler:function(e){var n=mn.eventHandlers[e];n.target.removeEventListener(n.eventTypeString,n.eventListenerFunc,n.useCapture),mn.eventHandlers.splice(e,1)},registerOrRemoveHandler:function(e){var n=function(n){++mn.inEventHandler,mn.currentEventHandler=e,mn.runDeferredCalls(),e.handlerFunc(n),mn.runDeferredCalls(),--mn.inEventHandler};if(e.callbackfunc)e.eventListenerFunc=n,e.target.addEventListener(e.eventTypeString,n,e.useCapture),mn.eventHandlers.push(e),mn.registerRemoveEventListeners();else for(var t=0;t<mn.eventHandlers.length;++t)mn.eventHandlers[t].target==e.target&&mn.eventHandlers[t].eventTypeString==e.eventTypeString&&mn._removeHandler(t--)},queueEventHandlerOnThread_iiii:function(e,n,t,a,r){var u=ot(),s=lt(12);i()[s>>2]=t,i()[s+4>>2]=a,i()[s+8>>2]=r,it(e,637534208,n,a,s),dt(u)},getTargetThreadForEventCallback:function(e){switch(e){case 1:return 0;case 2:return je.currentProxiedOperationCallerThread;default:return e}},getNodeNameForTarget:function(e){return e?e==window?"#window":e==screen?"#screen":e&&e.nodeName?e.nodeName:"":""},fullscreenEnabled:function(){return document.fullscreenEnabled||document.webkitFullscreenEnabled}};function fn(e){var n=q(e)+1,t=Qn(n);return z(e,t,n),t}function hn(e,n,t,a){var r=ot(),u=lt(12),s=0;n&&(s=fn(n)),i()[u>>2]=s,i()[u+4>>2]=t,i()[u+8>>2]=a,it(e,657457152,0,s,u),dt(r)}function bn(e,n,t,a){hn(e,n=n?H(n):"",t,a)}function _n(e){return e>2?H(e):e}var yn=[0,"undefined"!=typeof document?document:0,"undefined"!=typeof window?window:0];function gn(e){return e=_n(e),yn[e]||("undefined"!=typeof document?document.querySelector(e):void 0)}function wn(e){return gn(e)}function kn(e,n,t){var a=wn(e);if(!a)return-4;if(a.canvasSharedPtr&&(i()[a.canvasSharedPtr>>2]=n,i()[a.canvasSharedPtr+4>>2]=t),!a.offscreenCanvas&&a.controlTransferredOffscreen)return a.canvasSharedPtr?(bn(i()[a.canvasSharedPtr+8>>2],e,n,t),1):-4;a.offscreenCanvas&&(a=a.offscreenCanvas);var r=!1;if(a.GLctxObject&&a.GLctxObject.GLctx){var u=a.GLctxObject.GLctx.getParameter(2978);r=0===u[0]&&0===u[1]&&u[2]===a.width&&u[3]===a.height}return a.width=n,a.height=t,r&&a.GLctxObject.GLctx.viewport(0,0,n,t),0}function In(e,n,t){return y?un(2,1,e,n,t):kn(e,n,t)}function vn(e,n,t){return wn(e)?kn(e,n,t):In(e,n,t)}function Sn(e){}function En(e,n){}function An(e){var n=e.getExtension("ANGLE_instanced_arrays");if(n)return e.vertexAttribDivisor=function(e,t){n.vertexAttribDivisorANGLE(e,t)},e.drawArraysInstanced=function(e,t,a,r){n.drawArraysInstancedANGLE(e,t,a,r)},e.drawElementsInstanced=function(e,t,a,r,u){n.drawElementsInstancedANGLE(e,t,a,r,u)},1}function Mn(e){var n=e.getExtension("OES_vertex_array_object");if(n)return e.createVertexArray=function(){return n.createVertexArrayOES()},e.deleteVertexArray=function(e){n.deleteVertexArrayOES(e)},e.bindVertexArray=function(e){n.bindVertexArrayOES(e)},e.isVertexArray=function(e){return n.isVertexArrayOES(e)},1}function xn(e){var n=e.getExtension("WEBGL_draw_buffers");if(n)return e.drawBuffers=function(e,t){n.drawBuffersWEBGL(e,t)},1}var Nn={counter:1,lastError:0,buffers:[],mappedBuffers:{},programs:[],framebuffers:[],renderbuffers:[],textures:[],uniforms:[],shaders:[],vaos:[],contexts:{},currentContext:null,offscreenCanvases:{},timerQueriesEXT:[],programInfos:{},stringCache:{},unpackAlignment:4,init:function(){for(var e=new Float32Array(Nn.MINI_TEMP_BUFFER_SIZE),n=0;n<Nn.MINI_TEMP_BUFFER_SIZE;n++)Nn.miniTempBufferFloatViews[n]=e.subarray(0,n+1);var t=new Int32Array(Nn.MINI_TEMP_BUFFER_SIZE);for(n=0;n<Nn.MINI_TEMP_BUFFER_SIZE;n++)Nn.miniTempBufferIntViews[n]=t.subarray(0,n+1)},recordError:function(e){Nn.lastError||(Nn.lastError=e)},getNewId:function(e){for(var n=Nn.counter++,t=e.length;t<n;t++)e[t]=null;return n},MINI_TEMP_BUFFER_SIZE:256,miniTempBufferFloatViews:[0],miniTempBufferIntViews:[0],getSource:function(e,n,t,a){for(var r="",u=0;u<n;++u){var s=a?i()[a+4*u>>2]:-1;r+=H(i()[t+4*u>>2],s<0?void 0:s)}return r},createContext:function(e,n){var t=e.getContext("webgl",n);return t?Nn.registerContext(t,n):0},registerContext:function(e,n){var t=Qn(8);i()[t+4>>2]=zn();var a={handle:t,attributes:n,version:n.majorVersion,GLctx:e};return e.canvas&&(e.canvas.GLctxObject=a),Nn.contexts[t]=a,(void 0===n.enableExtensionsByDefault||n.enableExtensionsByDefault)&&Nn.initExtensions(a),t},makeContextCurrent:function(e){return Nn.currentContext=Nn.contexts[e],c.ctx=Cn=Nn.currentContext&&Nn.currentContext.GLctx,!(e&&!Cn)},getContext:function(e){return Nn.contexts[e]},deleteContext:function(e){Nn.currentContext===Nn.contexts[e]&&(Nn.currentContext=null),"object"==typeof mn&&mn.removeAllHandlersOnTarget(Nn.contexts[e].GLctx.canvas),Nn.contexts[e]&&Nn.contexts[e].GLctx.canvas&&(Nn.contexts[e].GLctx.canvas.GLctxObject=void 0),Zn(Nn.contexts[e].handle),Nn.contexts[e]=null},initExtensions:function(e){if(e||(e=Nn.currentContext),!e.initExtensionsDone){e.initExtensionsDone=!0;var n=e.GLctx;An(n),Mn(n),xn(n),n.disjointTimerQueryExt=n.getExtension("EXT_disjoint_timer_query");var t=["OES_texture_float","OES_texture_half_float","OES_standard_derivatives","OES_vertex_array_object","WEBGL_compressed_texture_s3tc","WEBGL_depth_texture","OES_element_index_uint","EXT_texture_filter_anisotropic","EXT_frag_depth","WEBGL_draw_buffers","ANGLE_instanced_arrays","OES_texture_float_linear","OES_texture_half_float_linear","EXT_blend_minmax","EXT_shader_texture_lod","EXT_texture_norm16","WEBGL_compressed_texture_pvrtc","EXT_color_buffer_half_float","WEBGL_color_buffer_float","EXT_sRGB","WEBGL_compressed_texture_etc1","EXT_disjoint_timer_query","WEBGL_compressed_texture_etc","WEBGL_compressed_texture_astc","EXT_color_buffer_float","WEBGL_compressed_texture_s3tc_srgb","EXT_disjoint_timer_query_webgl2","WEBKIT_WEBGL_compressed_texture_pvrtc"];(n.getSupportedExtensions()||[]).forEach((function(e){-1!=t.indexOf(e)&&n.getExtension(e)}))}},populateUniformTable:function(e){for(var n=Nn.programs[e],t=Nn.programInfos[e]={uniforms:{},maxUniformLength:0,maxAttributeLength:-1,maxUniformBlockNameLength:-1},a=t.uniforms,r=Cn.getProgramParameter(n,35718),u=0;u<r;++u){var s=Cn.getActiveUniform(n,u),i=s.name;t.maxUniformLength=Math.max(t.maxUniformLength,i.length+1),"]"==i.slice(-1)&&(i=i.slice(0,i.lastIndexOf("[")));var o=Cn.getUniformLocation(n,i);if(o){var l=Nn.getNewId(Nn.uniforms);a[i]=[s.size,l],Nn.uniforms[l]=o;for(var d=1;d<s.size;++d){var c=i+"["+d+"]";o=Cn.getUniformLocation(n,c),l=Nn.getNewId(Nn.uniforms),Nn.uniforms[l]=o}}}}},Fn=["default","low-power","high-performance"];function Tn(e,n){var t={},a=n>>2;t.alpha=!!i()[a+0],t.depth=!!i()[a+1],t.stencil=!!i()[a+2],t.antialias=!!i()[a+3],t.premultipliedAlpha=!!i()[a+4],t.preserveDrawingBuffer=!!i()[a+5];var r=i()[a+6];t.powerPreference=Fn[r],t.failIfMajorPerformanceCaveat=!!i()[a+7],t.majorVersion=i()[a+8],t.minorVersion=i()[a+9],t.enableExtensionsByDefault=i()[a+10],t.explicitSwapControl=i()[a+11],t.proxyContextToMainThread=i()[a+12],t.renderViaOffscreenBackBuffer=i()[a+13];var u=wn(e);return u?t.explicitSwapControl?-1:Nn.createContext(u,t):-4}function On(e,n){return Tn(e,n)}var Cn,Rn={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=Rn.buffers[e];0===n||10===n?((1===e?N:F)(L(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return Rn.varargs+=4,i()[Rn.varargs-4>>2]},getStr:function(e){return H(e)},get64:function(e,n){return e}};function Dn(e){return y?un(3,1,e):0}function Pn(e,n,t,a,r){if(y)return un(4,1,e,n,t,a,r)}function Wn(e,n,t,a){if(y)return un(5,1,e,n,t,a);for(var r=0,u=0;u<t;u++){for(var o=i()[n+8*u>>2],l=i()[n+(8*u+4)>>2],d=0;d<l;d++)Rn.printChar(e,s()[o+d]);r+=l}return i()[a>>2]=r,0}function Bn(e){var n=je.exitHandlers.pop();e&&n()}function Ln(e,n){null===je.exitHandlers&&(je.exitHandlers=[]),je.exitHandlers.push((function(){ct(e,n)}))}function Hn(e){if(y)throw"Internal Error! _spawn_thread() can only ever be called from main application thread!";var n=je.getNewWorker();if(void 0!==n.pthread)throw"Internal error!";if(!e.pthread_ptr)throw"Internal error, no pthread ptr!";je.runningWorkers.push(n);for(var t=Qn(512),a=0;a<128;++a)i()[t+4*a>>2]=0;var r=e.stackBase+e.stackSize,u=je.pthreads[e.pthread_ptr]={worker:n,stackBase:e.stackBase,stackSize:e.stackSize,allocatedOwnStack:e.allocatedOwnStack,thread:e.pthread_ptr,threadInfoStruct:e.pthread_ptr},s=u.threadInfoStruct>>2;Atomics.store(o(),s+0,0),Atomics.store(o(),s+1,0),Atomics.store(o(),s+2,0),Atomics.store(o(),s+17,e.detached),Atomics.store(o(),s+26,t),Atomics.store(o(),s+12,0),Atomics.store(o(),s+10,u.threadInfoStruct),Atomics.store(o(),s+11,42),Atomics.store(o(),s+27,e.stackSize),Atomics.store(o(),s+21,e.stackSize),Atomics.store(o(),s+20,r),Atomics.store(o(),s+29,r),Atomics.store(o(),s+30,e.detached),Atomics.store(o(),s+32,e.schedPolicy),Atomics.store(o(),s+33,e.schedPrio);var l=et()+40;Atomics.store(o(),s+44,l),n.pthread=u;var d={cmd:"run",start_routine:e.startRoutine,arg:e.arg,threadInfoStruct:e.pthread_ptr,selfThreadId:e.pthread_ptr,parentThreadId:e.parent_pthread_ptr,stackBase:e.stackBase,stackSize:e.stackSize};n.runPthread=function(){d.time=performance.now(),n.postMessage(d,e.transferList)},n.loaded&&(n.runPthread(),delete n.runPthread)}function Un(e,n,t){if(!n&&!t)return We.EINVAL;if(!e)return F("pthread_getschedparam called with a null thread pointer!"),We.ESRCH;if(i()[e+12>>2]!==e)return F("pthread_getschedparam attempted on thread "+e+", which does not point to a valid thread, or does not exist anymore!"),We.ESRCH;var a=Atomics.load(o(),e+108+20>>2),r=Atomics.load(o(),e+108+24>>2);return n&&(i()[n>>2]=a),t&&(i()[t>>2]=r),0}function zn(){return 0|Ce}function qn(e,n,t,a){if("undefined"==typeof SharedArrayBuffer)return F("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;if(!e)return F("pthread_create called with a null thread pointer!"),28;var r=[];if(y&&0===r.length)return ut(687865856,e,n,t,a);var u=0,s=0,l=0,d=0,c=0;if(n)if(u=i()[n>>2],u+=81920,s=i()[n+8>>2],l=0!==i()[n+12>>2],0===i()[n+16>>2]){var p=i()[n+20>>2],m=i()[n+24>>2];Un(je.currentProxiedOperationCallerThread?je.currentProxiedOperationCallerThread:zn(),n+20,n+24),d=i()[n+20>>2],c=i()[n+24>>2],i()[n+20>>2]=p,i()[n+24>>2]=m}else d=i()[n+20>>2],c=i()[n+24>>2];else u=2097152;var f=0==s;f?s=nt(16,u):D((s-=u)>0);for(var h=Qn(232),b=0;b<58;++b)o()[(h>>2)+b]=0;i()[e>>2]=h,i()[h+12>>2]=h;var _=h+156;i()[_>>2]=_;var g={stackBase:s,stackSize:u,allocatedOwnStack:f,schedPolicy:d,schedPrio:c,detached:l,startRoutine:t,pthread_ptr:h,parent_pthread_ptr:zn(),arg:a,transferList:r};return y?(g.cmd="spawnThread",postMessage(g,r)):Hn(g),0}function jn(e){return(e=+e)>=0?+he(e+.5):+fe(e-.5)}function Vn(e){if(y)return un(6,1,e);switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:case 79:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return $e(28),-1}c._pthread_self=zn,y?je.initWorker():je.initMainThreadBlock(),Nn.init();var Gn=[null,Ye,In,Dn,Pn,Wn,Vn],Kn={e:Ke,r:Xe,w:Qe,a:Ze,l:Je,d:en,c:Le,h:qe,g:nn,x:tn,q:an,B:rn,t:ln,A:pn,u:vn,k:Sn,s:En,v:On,m:Dn,o:Pn,i:Wn,p:Oe,memory:x||c.wasmMemory,y:Bn,z:Ln,j:qn,b:zn,f:jn,n:Vn,table:O},Xn=Fe();c.asm=Xn;var $n,Yn=c.___wasm_call_ctors=function(){return(Yn=c.___wasm_call_ctors=c.asm.C).apply(null,arguments)},Qn=(c._init=function(){return(c._init=c.asm.D).apply(null,arguments)},c._register_tensor=function(){return(c._register_tensor=c.asm.E).apply(null,arguments)},c._dispose_data=function(){return(c._dispose_data=c.asm.F).apply(null,arguments)},c._dispose=function(){return(c._dispose=c.asm.G).apply(null,arguments)},c._Abs=function(){return(c._Abs=c.asm.H).apply(null,arguments)},c._Add=function(){return(c._Add=c.asm.I).apply(null,arguments)},c._AddN=function(){return(c._AddN=c.asm.J).apply(null,arguments)},c._ArgMax=function(){return(c._ArgMax=c.asm.K).apply(null,arguments)},c._AvgPool=function(){return(c._AvgPool=c.asm.L).apply(null,arguments)},c._BatchMatMul=function(){return(c._BatchMatMul=c.asm.M).apply(null,arguments)},c._ClipByValue=function(){return(c._ClipByValue=c.asm.N).apply(null,arguments)},c._Conv2D=function(){return(c._Conv2D=c.asm.O).apply(null,arguments)},c._Conv2DBackpropInput=function(){return(c._Conv2DBackpropInput=c.asm.P).apply(null,arguments)},c._Cos=function(){return(c._Cos=c.asm.Q).apply(null,arguments)},c._CropAndResize=function(){return(c._CropAndResize=c.asm.R).apply(null,arguments)},c._Cumsum=function(){return(c._Cumsum=c.asm.S).apply(null,arguments)},c._DepthToSpace=function(){return(c._DepthToSpace=c.asm.T).apply(null,arguments)},c._DepthwiseConv2dNative=function(){return(c._DepthwiseConv2dNative=c.asm.U).apply(null,arguments)},c._Equal=function(){return(c._Equal=c.asm.V).apply(null,arguments)},c._Exp=function(){return(c._Exp=c.asm.W).apply(null,arguments)},c._FlipLeftRight=function(){return(c._FlipLeftRight=c.asm.X).apply(null,arguments)},c._Floor=function(){return(c._Floor=c.asm.Y).apply(null,arguments)},c._FloorDiv=function(){return(c._FloorDiv=c.asm.Z).apply(null,arguments)},c._FusedBatchNorm=function(){return(c._FusedBatchNorm=c.asm._).apply(null,arguments)},c._FusedConv2D=function(){return(c._FusedConv2D=c.asm.$).apply(null,arguments)},c._FusedDepthwiseConv2D=function(){return(c._FusedDepthwiseConv2D=c.asm.aa).apply(null,arguments)},c._Gather=function(){return(c._Gather=c.asm.ba).apply(null,arguments)},c._GatherNd=function(){return(c._GatherNd=c.asm.ca).apply(null,arguments)},c._Greater=function(){return(c._Greater=c.asm.da).apply(null,arguments)},c._GreaterEqual=function(){return(c._GreaterEqual=c.asm.ea).apply(null,arguments)},c._LeakyRelu=function(){return(c._LeakyRelu=c.asm.fa).apply(null,arguments)},c._Less=function(){return(c._Less=c.asm.ga).apply(null,arguments)},c._LessEqual=function(){return(c._LessEqual=c.asm.ha).apply(null,arguments)},c._Log=function(){return(c._Log=c.asm.ia).apply(null,arguments)},c._LogicalAnd=function(){return(c._LogicalAnd=c.asm.ja).apply(null,arguments)},c._Max=function(){return(c._Max=c.asm.ka).apply(null,arguments)},c._MaxPool=function(){return(c._MaxPool=c.asm.la).apply(null,arguments)},c._Maximum=function(){return(c._Maximum=c.asm.ma).apply(null,arguments)},c._Mean=function(){return(c._Mean=c.asm.na).apply(null,arguments)},c._Min=function(){return(c._Min=c.asm.oa).apply(null,arguments)},c._Minimum=function(){return(c._Minimum=c.asm.pa).apply(null,arguments)},c._Multiply=function(){return(c._Multiply=c.asm.qa).apply(null,arguments)},c._Neg=function(){return(c._Neg=c.asm.ra).apply(null,arguments)},c._NonMaxSuppressionV3=function(){return(c._NonMaxSuppressionV3=c.asm.sa).apply(null,arguments)},c._NonMaxSuppressionV4=function(){return(c._NonMaxSuppressionV4=c.asm.ta).apply(null,arguments)},c._NonMaxSuppressionV5=function(){return(c._NonMaxSuppressionV5=c.asm.ua).apply(null,arguments)},c._NotEqual=function(){return(c._NotEqual=c.asm.va).apply(null,arguments)},c._OneHot=function(){return(c._OneHot=c.asm.wa).apply(null,arguments)},c._PadV2=function(){return(c._PadV2=c.asm.xa).apply(null,arguments)},c._Pow=function(){return(c._Pow=c.asm.ya).apply(null,arguments)},c._Prelu=function(){return(c._Prelu=c.asm.za).apply(null,arguments)},c._Prod=function(){return(c._Prod=c.asm.Aa).apply(null,arguments)},c._RealDiv=function(){return(c._RealDiv=c.asm.Ba).apply(null,arguments)},c._Relu=function(){return(c._Relu=c.asm.Ca).apply(null,arguments)},c._Relu6=function(){return(c._Relu6=c.asm.Da).apply(null,arguments)},c._ResizeBilinear=function(){return(c._ResizeBilinear=c.asm.Ea).apply(null,arguments)},c._Reverse=function(){return(c._Reverse=c.asm.Fa).apply(null,arguments)},c._RotateWithOffset=function(){return(c._RotateWithOffset=c.asm.Ga).apply(null,arguments)},c._Rsqrt=function(){return(c._Rsqrt=c.asm.Ha).apply(null,arguments)},c._ScatterNd=function(){return(c._ScatterNd=c.asm.Ia).apply(null,arguments)},c._SelectV2=function(){return(c._SelectV2=c.asm.Ja).apply(null,arguments)},c._Sigmoid=function(){return(c._Sigmoid=c.asm.Ka).apply(null,arguments)},c._Sin=function(){return(c._Sin=c.asm.La).apply(null,arguments)},c._Softmax=function(){return(c._Softmax=c.asm.Ma).apply(null,arguments)},c._Sqrt=function(){return(c._Sqrt=c.asm.Na).apply(null,arguments)},c._Square=function(){return(c._Square=c.asm.Oa).apply(null,arguments)},c._SquaredDifference=function(){return(c._SquaredDifference=c.asm.Pa).apply(null,arguments)},c._StridedSlice=function(){return(c._StridedSlice=c.asm.Qa).apply(null,arguments)},c._Sub=function(){return(c._Sub=c.asm.Ra).apply(null,arguments)},c._Sum=function(){return(c._Sum=c.asm.Sa).apply(null,arguments)},c._Tanh=function(){return(c._Tanh=c.asm.Ta).apply(null,arguments)},c._Tile=function(){return(c._Tile=c.asm.Ua).apply(null,arguments)},c._TopK=function(){return(c._TopK=c.asm.Va).apply(null,arguments)},c._Transpose=function(){return(c._Transpose=c.asm.Wa).apply(null,arguments)},c.__FusedMatMul=function(){return(c.__FusedMatMul=c.asm.Xa).apply(null,arguments)},c._malloc=function(){return(Qn=c._malloc=c.asm.Ya).apply(null,arguments)}),Zn=c._free=function(){return(Zn=c._free=c.asm.Za).apply(null,arguments)},Jn=c.___errno_location=function(){return(Jn=c.___errno_location=c.asm._a).apply(null,arguments)},et=c._emscripten_get_global_libc=function(){return(et=c._emscripten_get_global_libc=c.asm.$a).apply(null,arguments)},nt=(c.___em_js__initPthreadsJS=function(){return(c.___em_js__initPthreadsJS=c.asm.ab).apply(null,arguments)},c._memalign=function(){return(nt=c._memalign=c.asm.bb).apply(null,arguments)}),tt=c.___pthread_tsd_run_dtors=function(){return(tt=c.___pthread_tsd_run_dtors=c.asm.cb).apply(null,arguments)},at=c._emscripten_main_thread_process_queued_calls=function(){return(at=c._emscripten_main_thread_process_queued_calls=c.asm.db).apply(null,arguments)},rt=(c._emscripten_current_thread_process_queued_calls=function(){return(c._emscripten_current_thread_process_queued_calls=c.asm.eb).apply(null,arguments)},c._emscripten_register_main_browser_thread_id=function(){return(rt=c._emscripten_register_main_browser_thread_id=c.asm.fb).apply(null,arguments)}),ut=(c._emscripten_main_browser_thread_id=function(){return(c._emscripten_main_browser_thread_id=c.asm.gb).apply(null,arguments)},c._emscripten_async_run_in_main_thread=function(){return(c._emscripten_async_run_in_main_thread=c.asm.hb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread=function(){return(c._emscripten_sync_run_in_main_thread=c.asm.ib).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_0=function(){return(c._emscripten_sync_run_in_main_thread_0=c.asm.jb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_1=function(){return(c._emscripten_sync_run_in_main_thread_1=c.asm.kb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_2=function(){return(c._emscripten_sync_run_in_main_thread_2=c.asm.lb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_xprintf_varargs=function(){return(c._emscripten_sync_run_in_main_thread_xprintf_varargs=c.asm.mb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_3=function(){return(c._emscripten_sync_run_in_main_thread_3=c.asm.nb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_4=function(){return(ut=c._emscripten_sync_run_in_main_thread_4=c.asm.ob).apply(null,arguments)}),st=(c._emscripten_sync_run_in_main_thread_5=function(){return(c._emscripten_sync_run_in_main_thread_5=c.asm.pb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_6=function(){return(c._emscripten_sync_run_in_main_thread_6=c.asm.qb).apply(null,arguments)},c._emscripten_sync_run_in_main_thread_7=function(){return(c._emscripten_sync_run_in_main_thread_7=c.asm.rb).apply(null,arguments)},c._emscripten_run_in_main_runtime_thread_js=function(){return(st=c._emscripten_run_in_main_runtime_thread_js=c.asm.sb).apply(null,arguments)}),it=c._emscripten_async_queue_on_thread_=function(){return(it=c._emscripten_async_queue_on_thread_=c.asm.tb).apply(null,arguments)},ot=(c._emscripten_tls_init=function(){return(c._emscripten_tls_init=c.asm.ub).apply(null,arguments)},c.stackSave=function(){return(ot=c.stackSave=c.asm.vb).apply(null,arguments)}),lt=c.stackAlloc=function(){return(lt=c.stackAlloc=c.asm.wb).apply(null,arguments)},dt=c.stackRestore=function(){return(dt=c.stackRestore=c.asm.xb).apply(null,arguments)},ct=c.dynCall_vi=function(){return(ct=c.dynCall_vi=c.asm.yb).apply(null,arguments)};function pt(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function mt(e){function n(){$n||($n=!0,c.calledRun=!0,R||(le(),de(),c.onRuntimeInitialized&&c.onRuntimeInitialized(),ce()))}be>0||(oe(),be>0||(c.setStatus?(c.setStatus("Running..."),setTimeout((function(){setTimeout((function(){c.setStatus("")}),1),n()}),1)):n()))}if(c.dynCall_v=function(){return(c.dynCall_v=c.asm.zb).apply(null,arguments)},c.dynCall_ii=function(){return(c.dynCall_ii=c.asm.Ab).apply(null,arguments)},c.asm=Xn,c.cwrap=B,c.PThread=je,c.PThread=je,c._pthread_self=zn,c.wasmMemory=x,c.ExitStatus=pt,c.then=function(e){if($n)e(c);else{var n=c.onRuntimeInitialized;c.onRuntimeInitialized=function(){n&&n(),e(c)}}return c},ye=function e(){$n||mt(),$n||(ye=e)},c.run=mt,c.preInit)for("function"==typeof c.preInit&&(c.preInit=[c.preInit]);c.preInit.length>0;)c.preInit.pop()();return y||(M=!0),y||mt(),e});e.exports=i}));var Ne=Me((function(e,n){var r,u=(r="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(r=r||__filename),function(e){var n,u=void 0!==(e=e||{})?e:{},s={};for(n in u)u.hasOwnProperty(n)&&(s[n]=u[n]);var i=function(e,n){throw n},o=!1,l=!1,d=!1,c=!1;o="object"==typeof window,l="function"==typeof importScripts,d="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,c=!o&&!d&&!l;var p,m,f,h,b="";function _(e){return u.locateFile?u.locateFile(e,b):b+e}d?(b=l?t.dirname(b)+"/":__dirname+"/",p=function(e,n){return f||(f=a),h||(h=t),e=h.normalize(e),f.readFileSync(e,n?null:"utf8")},m=function(e){var n=p(e,!0);return n.buffer||(n=new Uint8Array(n)),S(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Ae))throw e})),process.on("unhandledRejection",te),i=function(e){process.exit(e)},u.inspect=function(){return"[Emscripten Module object]"}):c?("undefined"!=typeof read&&(p=function(e){return read(e)}),m=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(S("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"function"==typeof quit&&(i=function(e){quit(e)}),"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(o||l)&&(l?b=self.location.href:document.currentScript&&(b=document.currentScript.src),r&&(b=r),b=0!==b.indexOf("blob:")?b.substr(0,b.lastIndexOf("/")+1):"",p=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},l&&(m=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}));var y,g,w,k=u.print||console.log.bind(console),I=u.printErr||console.warn.bind(console);for(n in s)s.hasOwnProperty(n)&&(u[n]=s[n]);s=null,u.arguments&&u.arguments,u.thisProgram&&u.thisProgram,u.quit&&(i=u.quit),u.wasmBinary&&(y=u.wasmBinary),u.noExitRuntime&&(g=u.noExitRuntime),"object"!=typeof WebAssembly&&I("no native wasm support detected"),new WebAssembly.Table({initial:149,maximum:149,element:"anyfunc"});var v=!1;function S(e,n){e||te("Assertion failed: "+n)}function E(e){var n=u["_"+e];return S(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function A(e,n,t,a,r){var u={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);D(e,n=Se(t),t)}return n},array:function(e){var n=Se(e.length);return P(e,n),n}},s=E(e),i=[],o=0;if(a)for(var l=0;l<a.length;l++){var d=u[t[l]];d?(0===o&&(o=ve()),i[l]=d(a[l])):i[l]=a[l]}var c=s.apply(null,i);return c=function(e){return"string"===n?C(e):"boolean"===n?Boolean(e):e}(c),0!==o&&Ee(o),c}function M(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?E(e):function(){return A(e,n,t,arguments)}}var x,N,F,T="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function O(e,n,t){for(var a=n+t,r=n;e[r]&&!(r>=a);)++r;if(r-n>16&&e.subarray&&T)return T.decode(e.subarray(n,r));for(var u="";n<r;){var s=e[n++];if(128&s){var i=63&e[n++];if(192!=(224&s)){var o=63&e[n++];if((s=224==(240&s)?(15&s)<<12|i<<6|o:(7&s)<<18|i<<12|o<<6|63&e[n++])<65536)u+=String.fromCharCode(s);else{var l=s-65536;u+=String.fromCharCode(55296|l>>10,56320|1023&l)}}else u+=String.fromCharCode((31&s)<<6|i)}else u+=String.fromCharCode(s)}return u}function C(e,n){return e?O(N,e,n):""}function R(e,n,t,a){if(!(a>0))return 0;for(var r=t,u=t+a-1,s=0;s<e.length;++s){var i=e.charCodeAt(s);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++s)),i<=127){if(t>=u)break;n[t++]=i}else if(i<=2047){if(t+1>=u)break;n[t++]=192|i>>6,n[t++]=128|63&i}else if(i<=65535){if(t+2>=u)break;n[t++]=224|i>>12,n[t++]=128|i>>6&63,n[t++]=128|63&i}else{if(t+3>=u)break;n[t++]=240|i>>18,n[t++]=128|i>>12&63,n[t++]=128|i>>6&63,n[t++]=128|63&i}}return n[t]=0,t-r}function D(e,n,t){return R(e,N,n,t)}function P(e,n){x.set(e,n)}function W(e){u.HEAP8=x=new Int8Array(e),u.HEAP16=new Int16Array(e),u.HEAP32=F=new Int32Array(e),u.HEAPU8=N=new Uint8Array(e),u.HEAPU16=new Uint16Array(e),u.HEAPU32=new Uint32Array(e),u.HEAPF32=new Float32Array(e),u.HEAPF64=new Float64Array(e)}function B(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?u.dynCall_v(t):u.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n(u)}}u.INITIAL_MEMORY;var L=[],H=[],U=[],z=[];function q(){if(u.preRun)for("function"==typeof u.preRun&&(u.preRun=[u.preRun]);u.preRun.length;)K(u.preRun.shift());B(L)}function j(){B(H)}function V(){B(U)}function G(){if(u.postRun)for("function"==typeof u.postRun&&(u.postRun=[u.postRun]);u.postRun.length;)X(u.postRun.shift());B(z)}function K(e){L.unshift(e)}function X(e){z.unshift(e)}var $=Math.ceil,Y=Math.floor,Q=0,Z=null,J=null;function ee(e){Q++,u.monitorRunDependencies&&u.monitorRunDependencies(Q)}function ne(e){if(Q--,u.monitorRunDependencies&&u.monitorRunDependencies(Q),0==Q&&(null!==Z&&(clearInterval(Z),Z=null),J)){var n=J;J=null,n()}}function te(e){throw u.onAbort&&u.onAbort(e),k(e+=""),I(e),v=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}function ae(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}u.preloadedImages={},u.preloadedAudios={};var re="data:application/octet-stream;base64,";function ue(e){return ae(e,re)}var se="file://";function ie(e){return ae(e,se)}var oe="tfjs-backend-wasm.wasm";function le(){try{if(y)return new Uint8Array(y);if(m)return m(oe);throw"both async and sync fetching of the wasm failed"}catch(e){te(e)}}function de(){return y||!o&&!l||"function"!=typeof fetch||ie(oe)?new Promise((function(e,n){e(le())})):fetch(oe,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+oe+"'";return e.arrayBuffer()})).catch((function(){return le()}))}function ce(){var e={env:we,wasi_snapshot_preview1:we};function n(e,n){var t=e.exports;u.asm=t,W((w=t.memory).buffer),ne()}function t(e){n(e.instance)}function a(n){return de().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){I("failed to asynchronously prepare wasm: "+e),te(e)}))}if(ee(),u.instantiateWasm)try{return u.instantiateWasm(e,n)}catch(e){return I("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(y||"function"!=typeof WebAssembly.instantiateStreaming||ue(oe)||ie(oe)||"function"!=typeof fetch)return a(t);fetch(oe,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){I("wasm streaming compile failed: "+e),I("falling back to ArrayBuffer instantiation"),a(t)}))}))}(),{}}function pe(e){W(w.buffer)}ue(oe)||(oe=_(oe)),H.push();var me={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=me.buffers[e];0===n||10===n?((1===e?k:I)(O(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return me.varargs+=4,F[me.varargs-4>>2]},getStr:function(e){return C(e)},get64:function(e,n){return e}};function fe(e){return 0}function he(e,n,t,a,r){}function be(e,n,t,a){for(var r=0,u=0;u<t;u++){for(var s=F[n+8*u>>2],i=F[n+(8*u+4)>>2],o=0;o<i;o++)me.printChar(e,N[s+o]);r+=i}return F[a>>2]=r,0}function _e(e){Ne(e)}function ye(e){_e(e)}function ge(e){return(e=+e)>=0?+Y(e+.5):+$(e-.5)}var we={emscripten_notify_memory_growth:pe,fd_close:fe,fd_seek:he,fd_write:be,proc_exit:ye,roundf:ge},ke=ce();u.asm=ke,u._init=function(){return(u._init=u.asm.init).apply(null,arguments)},u._register_tensor=function(){return(u._register_tensor=u.asm.register_tensor).apply(null,arguments)},u._dispose_data=function(){return(u._dispose_data=u.asm.dispose_data).apply(null,arguments)},u._dispose=function(){return(u._dispose=u.asm.dispose).apply(null,arguments)},u._Abs=function(){return(u._Abs=u.asm.Abs).apply(null,arguments)},u._Add=function(){return(u._Add=u.asm.Add).apply(null,arguments)},u._AddN=function(){return(u._AddN=u.asm.AddN).apply(null,arguments)},u._ArgMax=function(){return(u._ArgMax=u.asm.ArgMax).apply(null,arguments)},u._AvgPool=function(){return(u._AvgPool=u.asm.AvgPool).apply(null,arguments)},u._BatchMatMul=function(){return(u._BatchMatMul=u.asm.BatchMatMul).apply(null,arguments)},u._ClipByValue=function(){return(u._ClipByValue=u.asm.ClipByValue).apply(null,arguments)},u._Conv2D=function(){return(u._Conv2D=u.asm.Conv2D).apply(null,arguments)},u._Conv2DBackpropInput=function(){return(u._Conv2DBackpropInput=u.asm.Conv2DBackpropInput).apply(null,arguments)},u._Cos=function(){return(u._Cos=u.asm.Cos).apply(null,arguments)},u._CropAndResize=function(){return(u._CropAndResize=u.asm.CropAndResize).apply(null,arguments)},u._Cumsum=function(){return(u._Cumsum=u.asm.Cumsum).apply(null,arguments)},u._DepthToSpace=function(){return(u._DepthToSpace=u.asm.DepthToSpace).apply(null,arguments)},u._DepthwiseConv2dNative=function(){return(u._DepthwiseConv2dNative=u.asm.DepthwiseConv2dNative).apply(null,arguments)},u._Equal=function(){return(u._Equal=u.asm.Equal).apply(null,arguments)},u._Exp=function(){return(u._Exp=u.asm.Exp).apply(null,arguments)},u._FlipLeftRight=function(){return(u._FlipLeftRight=u.asm.FlipLeftRight).apply(null,arguments)},u._Floor=function(){return(u._Floor=u.asm.Floor).apply(null,arguments)},u._FloorDiv=function(){return(u._FloorDiv=u.asm.FloorDiv).apply(null,arguments)},u._FusedBatchNorm=function(){return(u._FusedBatchNorm=u.asm.FusedBatchNorm).apply(null,arguments)},u._FusedConv2D=function(){return(u._FusedConv2D=u.asm.FusedConv2D).apply(null,arguments)},u._FusedDepthwiseConv2D=function(){return(u._FusedDepthwiseConv2D=u.asm.FusedDepthwiseConv2D).apply(null,arguments)},u._Gather=function(){return(u._Gather=u.asm.Gather).apply(null,arguments)},u._GatherNd=function(){return(u._GatherNd=u.asm.GatherNd).apply(null,arguments)},u._Greater=function(){return(u._Greater=u.asm.Greater).apply(null,arguments)},u._GreaterEqual=function(){return(u._GreaterEqual=u.asm.GreaterEqual).apply(null,arguments)},u._LeakyRelu=function(){return(u._LeakyRelu=u.asm.LeakyRelu).apply(null,arguments)},u._Less=function(){return(u._Less=u.asm.Less).apply(null,arguments)},u._LessEqual=function(){return(u._LessEqual=u.asm.LessEqual).apply(null,arguments)},u._Log=function(){return(u._Log=u.asm.Log).apply(null,arguments)},u._LogicalAnd=function(){return(u._LogicalAnd=u.asm.LogicalAnd).apply(null,arguments)},u._Max=function(){return(u._Max=u.asm.Max).apply(null,arguments)},u._MaxPool=function(){return(u._MaxPool=u.asm.MaxPool).apply(null,arguments)},u._Maximum=function(){return(u._Maximum=u.asm.Maximum).apply(null,arguments)},u._Mean=function(){return(u._Mean=u.asm.Mean).apply(null,arguments)},u._Min=function(){return(u._Min=u.asm.Min).apply(null,arguments)},u._Minimum=function(){return(u._Minimum=u.asm.Minimum).apply(null,arguments)},u._Multiply=function(){return(u._Multiply=u.asm.Multiply).apply(null,arguments)},u._Neg=function(){return(u._Neg=u.asm.Neg).apply(null,arguments)},u._NonMaxSuppressionV3=function(){return(u._NonMaxSuppressionV3=u.asm.NonMaxSuppressionV3).apply(null,arguments)},u._NonMaxSuppressionV4=function(){return(u._NonMaxSuppressionV4=u.asm.NonMaxSuppressionV4).apply(null,arguments)},u._NonMaxSuppressionV5=function(){return(u._NonMaxSuppressionV5=u.asm.NonMaxSuppressionV5).apply(null,arguments)},u._NotEqual=function(){return(u._NotEqual=u.asm.NotEqual).apply(null,arguments)},u._OneHot=function(){return(u._OneHot=u.asm.OneHot).apply(null,arguments)},u._PadV2=function(){return(u._PadV2=u.asm.PadV2).apply(null,arguments)},u._Pow=function(){return(u._Pow=u.asm.Pow).apply(null,arguments)},u._Prelu=function(){return(u._Prelu=u.asm.Prelu).apply(null,arguments)},u._Prod=function(){return(u._Prod=u.asm.Prod).apply(null,arguments)},u._RealDiv=function(){return(u._RealDiv=u.asm.RealDiv).apply(null,arguments)},u._Relu=function(){return(u._Relu=u.asm.Relu).apply(null,arguments)},u._Relu6=function(){return(u._Relu6=u.asm.Relu6).apply(null,arguments)},u._ResizeBilinear=function(){return(u._ResizeBilinear=u.asm.ResizeBilinear).apply(null,arguments)},u._Reverse=function(){return(u._Reverse=u.asm.Reverse).apply(null,arguments)},u._RotateWithOffset=function(){return(u._RotateWithOffset=u.asm.RotateWithOffset).apply(null,arguments)},u._Rsqrt=function(){return(u._Rsqrt=u.asm.Rsqrt).apply(null,arguments)},u._ScatterNd=function(){return(u._ScatterNd=u.asm.ScatterNd).apply(null,arguments)},u._SelectV2=function(){return(u._SelectV2=u.asm.SelectV2).apply(null,arguments)},u._Sigmoid=function(){return(u._Sigmoid=u.asm.Sigmoid).apply(null,arguments)},u._Sin=function(){return(u._Sin=u.asm.Sin).apply(null,arguments)},u._Softmax=function(){return(u._Softmax=u.asm.Softmax).apply(null,arguments)},u._Sqrt=function(){return(u._Sqrt=u.asm.Sqrt).apply(null,arguments)},u._Square=function(){return(u._Square=u.asm.Square).apply(null,arguments)},u._SquaredDifference=function(){return(u._SquaredDifference=u.asm.SquaredDifference).apply(null,arguments)},u._StridedSlice=function(){return(u._StridedSlice=u.asm.StridedSlice).apply(null,arguments)},u._Sub=function(){return(u._Sub=u.asm.Sub).apply(null,arguments)},u._Sum=function(){return(u._Sum=u.asm.Sum).apply(null,arguments)},u._Tanh=function(){return(u._Tanh=u.asm.Tanh).apply(null,arguments)},u._Tile=function(){return(u._Tile=u.asm.Tile).apply(null,arguments)},u._TopK=function(){return(u._TopK=u.asm.TopK).apply(null,arguments)},u._Transpose=function(){return(u._Transpose=u.asm.Transpose).apply(null,arguments)},u.__FusedMatMul=function(){return(u.__FusedMatMul=u.asm._FusedMatMul).apply(null,arguments)},u._malloc=function(){return(u._malloc=u.asm.malloc).apply(null,arguments)},u._free=function(){return(u._free=u.asm.free).apply(null,arguments)},u.__start=function(){return(u.__start=u.asm._start).apply(null,arguments)};var Ie,ve=u.stackSave=function(){return(ve=u.stackSave=u.asm.stackSave).apply(null,arguments)},Se=u.stackAlloc=function(){return(Se=u.stackAlloc=u.asm.stackAlloc).apply(null,arguments)},Ee=u.stackRestore=function(){return(Ee=u.stackRestore=u.asm.stackRestore).apply(null,arguments)};function Ae(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function Me(e){var n=u.__start;try{n(),Ne(0,!0)}catch(e){if(e instanceof Ae)return;if("unwind"==e)return void(g=!0);var t=e;e&&"object"==typeof e&&e.stack&&(t=[e,e.stack]),I("exception thrown: "+t),i(1,e)}}function xe(e){function n(){Ie||(Ie=!0,u.calledRun=!0,v||(j(),V(),u.onRuntimeInitialized&&u.onRuntimeInitialized(),Fe&&Me(),G()))}Q>0||(q(),Q>0||(u.setStatus?(u.setStatus("Running..."),setTimeout((function(){setTimeout((function(){u.setStatus("")}),1),n()}),1)):n()))}function Ne(e,n){n&&g&&0===e||(g||(v=!0,u.onExit&&u.onExit(e)),i(e,new Ae(e)))}if(u.asm=ke,u.cwrap=M,u.then=function(e){if(Ie)e(u);else{var n=u.onRuntimeInitialized;u.onRuntimeInitialized=function(){n&&n(),e(u)}}return u},J=function e(){Ie||xe(),Ie||(J=e)},u.run=xe,u.preInit)for("function"==typeof u.preInit&&(u.preInit=[u.preInit]);u.preInit.length>0;)u.preInit.pop()();var Fe=!0;return u.noInitialRun&&(Fe=!1),g=!0,xe(),e});e.exports=u}));class Fe extends n.KernelBackend{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.init(),this.dataIdMap=new n.DataStorage(this,n.engine())}write(e,n,t){const a={};return this.move(a,e,n,t),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const t=n.util.now();e();return{kernelMs:n.util.now()-t}}move(e,t,a,r){const u=this.dataIdNextNumber++;if("string"===r){const n=t;return void this.dataIdMap.set(e,{id:u,stringBytes:n,shape:a,dtype:r,memoryOffset:null})}const s=n.util.sizeFromShape(a),i=s*n.util.bytesPerElement(r),o=this.wasm._malloc(i);this.dataIdMap.set(e,{id:u,memoryOffset:o,shape:a,dtype:r}),this.wasm.tfjs.registerTensor(u,s,o),null!=t&&this.wasm.HEAPU8.set(new Uint8Array(t.buffer,t.byteOffset,i),o)}async read(e){return this.readSync(e)}readSync(e){const{memoryOffset:t,dtype:a,shape:r,stringBytes:u}=this.dataIdMap.get(e);if("string"===a)return u;return function(e,n){switch(n){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error("Unknown dtype "+n)}}(this.wasm.HEAPU8.slice(t,t+n.util.sizeFromShape(r)*n.util.bytesPerElement(a)).buffer,a)}disposeData(e){const n=this.dataIdMap.get(e);this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,t,a){let r;if(null==a)r=this.write(null,e,t);else{r={};const u=this.dataIdNextNumber++;this.dataIdMap.set(r,{id:u,memoryOffset:a,shape:e,dtype:t});const s=n.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(u,s,a)}return{dataId:r,shape:e,dtype:t}}typedArrayFromHeap({shape:e,dtype:t,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:u}=this.dataIdMap.get(a),s=n.util.sizeFromShape(e);switch(t){case"float32":return new Float32Array(r,u,s);case"int32":return new Int32Array(r,u,s);case"bool":return new Uint8Array(r,u,s);default:throw new Error("Unknown dtype "+t)}}}function Te(e,n,t){if(null!=Re)return Re;let a="tfjs-backend-wasm.wasm";return e&&n?a="tfjs-backend-wasm-threaded-simd.wasm":e&&(a="tfjs-backend-wasm-simd.wasm"),null!=Pe&&null!=Pe[a]?Pe[a]:t+a}async function Oe(){const[e,t]=await Promise.all([n.env().getAsync("WASM_HAS_SIMD_SUPPORT"),n.env().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")]);return new Promise((a,r)=>{const u={};let s;u.locateFile=(n,a)=>{if(n.endsWith(".worker.js")){const e=new Blob(['var threadInfoStruct=0;var selfThreadId=0;var parentThreadId=0;var Module={};function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:selfThreadId})}var err=threadPrintErr;this.alert=threadAlert;Module["instantiateWasm"]=function(info,receiveInstance){var instance=new WebAssembly.Instance(Module["wasmModule"],info);Module["wasmModule"]=null;receiveInstance(instance);return instance.exports};this.onmessage=function(e){try{if(e.data.cmd==="load"){Module["DYNAMIC_BASE"]=e.data.DYNAMIC_BASE;Module["DYNAMICTOP_PTR"]=e.data.DYNAMICTOP_PTR;Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob==="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}Module=WasmBackendModuleThreadedSimd(Module);postMessage({"cmd":"loaded"})}else if(e.data.cmd==="objectTransfer"){Module["PThread"].receiveObjectTransfer(e.data)}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;threadInfoStruct=e.data.threadInfoStruct;Module["__register_pthread_ptr"](threadInfoStruct,0,0);selfThreadId=e.data.selfThreadId;parentThreadId=e.data.parentThreadId;var max=e.data.stackBase;var top=e.data.stackBase+e.data.stackSize;Module["establishStackSpace"](top,max);Module["_emscripten_tls_init"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].setThreadStatus(Module["_pthread_self"](),1);try{var result=Module["dynCall_ii"](e.data.start_routine,e.data.arg);if(!Module["getNoExitRuntime"]())Module["PThread"].threadExit(result)}catch(ex){if(ex==="Canceled!"){Module["PThread"].threadCancel()}else if(ex!="unwind"){Atomics.store(Module["HEAPU32"],threadInfoStruct+4>>2,ex instanceof Module["ExitStatus"]?ex.status:-2);Atomics.store(Module["HEAPU32"],threadInfoStruct+0>>2,1);Module["_emscripten_futex_wake"](threadInfoStruct+0,2147483647);if(!(ex instanceof Module["ExitStatus"]))throw ex}}}else if(e.data.cmd==="cancel"){if(threadInfoStruct){Module["PThread"].threadCancel()}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processThreadQueue"){if(threadInfoStruct){Module["_emscripten_current_thread_process_queued_calls"]()}}else{err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){err("worker.js onmessage() captured an uncaught exception: "+ex);if(ex.stack)err(ex.stack);throw ex}};if(typeof process==="object"&&typeof process.versions==="object"&&typeof process.versions.node==="string"){self={location:{href:__filename}};var onmessage=this.onmessage;var nodeWorkerThreads=require("worker_threads");Worker=nodeWorkerThreads.Worker;var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",function(data){onmessage({data:data})});var nodeFS=require("fs");var nodeRead=function(filename){return nodeFS.readFileSync(filename,"utf8")};function globalEval(x){global.require=require;global.Module=Module;eval.call(null,x)}importScripts=function(f){globalEval(nodeRead(f))};postMessage=function(msg){parentPort.postMessage(msg)};if(typeof performance==="undefined"){performance={now:function(){return Date.now()}}}}'],{type:"application/javascript"});return URL.createObjectURL(e)}return n.endsWith(".wasm")?Te(e,t,null!=De?De:a):a+n},Be&&(u.instantiateWasm=function(e){return(t,a)=>(n.util.fetch(e,{credentials:"same-origin"}).then(n=>{n.ok||t.env.a(`failed to load wasm binary file at '${e}'`),n.arrayBuffer().then(e=>{WebAssembly.instantiate(e,t).then(e=>{a(e.instance)})})}),{})}(Te(e,t,null!=De?De:""))),t&&e&&null==Re?(s=xe(u),s.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+xe.toString()],{type:"text/javascript"})):s=Ne(u);s.tfjs={init:s.cwrap("init",null,[]),registerTensor:s.cwrap("register_tensor",null,["number","number","number"]),disposeData:s.cwrap("dispose_data",null,["number"]),dispose:s.cwrap("dispose",null,[])};let i=!1;s.onRuntimeInitialized=()=>{i=!0,We=!1,a({wasm:s})},s.onAbort=()=>{if(i)return;if(We)return;We=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})}})}const Ce=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"];let Re=null,De=null,Pe={},We=!1,Be=!1;n.registerBackend("wasm",async()=>{const{wasm:e}=await Oe();return new Fe(e)},2),e.BackendWasm=Fe,e.setWasmPath=function(e,t=!1){if(n.deprecationWarn("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),We)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");Re=e,Be=t},e.setWasmPaths=function(e,n=!1){if(We)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)De=e;else{Pe=e;const n=Ce.filter(e=>null==Pe[e]);if(n.length>0)throw new Error("There were no entries found for the following binaries: "+n.join(",")+". Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.")}Be=n},e.version_wasm="2.8.1",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.es2017.min.js.map
